function CADLIVE_DispFigure( timeStep, y , y_tag)
%   timeStep: time
%   y       : values for dependent variables
%   y_tag   : tags for y 

% maximum number of variables to be displayed in figure : 64

%%%%%%%%%%%%%% User edit %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% input the indices of y to be displayed
select = [1];
% graph type;
% 1. plot dynamics of selected variables on a single figure
% 2. plot dynamics of 4 variables per a single figure
% 3. both 1. and 2.
type = 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%\vf̐
selen=length(select);

tag = cell(1, selen);
for i=1:1:selen
    tag(i) = cellstr( y_tag(select(i)) );
end

%plot̏ꍇ
if type==1 || type==3
    figure;
    hold on
    plot(timeStep,y(:,select),'o-');
    colormap('Lines');
    legend(tag,'Location','Best');
    set(gca,'FontName','Arial');
    xlabel('Time','FontName','Arial');
    ylabel('Concentration','FontName','Arial');
    hold off
end

%subplot̏ꍇ
%subplotłSЂƂ̃Otɕ\
if type==2 || type==3
    figure;
    hold on
    %evf̐Fݒ
    cmap = colormap('Lines');
    for i=1:selen
        c(i,:) = cmap(i,:);
    end
    i=0;
    while i~=selen
        i=i+1;
        pplace=mod(i,4);%\ꏊ
        if mod(i,4)==1
            if i~=1
                figure;
                hold on
            end
        elseif mod(i,4)==0
            pplace=4;
        end
        
        subplot(2,2,pplace);
        plot(timeStep,y(:,select(i)),'o-','Color',c(i,:));
        legend(tag(i),'Location','Best');
        set(gca,'FontName','Arial');
        xlabel('Time','FontName','Arial');
        ylabel('Concentration','FontName','Arial');
        
        if mod(i,4)==0
            hold off
        end
        
    end
end
