function varargout = CADLIVE_DispResult(varargin)
% CADLIVE_DISPRESULT M-file for CADLIVE_DispResult.fig
%      CADLIVE_DISPRESULT, by itself, creates a new CADLIVE_DISPRESULT or raises the existing
%      singleton*.
%
%      H = CADLIVE_DISPRESULT returns the handle to a new CADLIVE_DISPRESULT or the handle to
%      the existing singleton*.
%
%      CADLIVE_DISPRESULT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CADLIVE_DISPRESULT.M with the given input arguments.
%
%      CADLIVE_DISPRESULT('Property','Value',...) creates a new CADLIVE_DISPRESULT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CADLIVE_DispResult_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CADLIVE_DispResult_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CADLIVE_DispResult

% Last Modified by GUIDE v2.5 25-Sep-2012 21:00:38

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CADLIVE_DispResult_OpeningFcn, ...
                   'gui_OutputFcn',  @CADLIVE_DispResult_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CADLIVE_DispResult is made visible.
function CADLIVE_DispResult_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CADLIVE_DispResult (see VARARGIN)

% Choose default command line output for CADLIVE_DispResult
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

if(nargin > 3)
    for index = 1:2:(nargin-3),
        switch varargin{index}
        case CADLIVE_SelectChemO.Name
            selectChemO = varargin{index+1};
            setappdata(handles.figResult, varargin{index}, selectChemO);
        case CADLIVE_EditUsrFuncO.Name
            editUsrFuncO = varargin{index+1};
            setappdata(handles.figResult, varargin{index}, editUsrFuncO);
        case CADLIVE_SetCtrlO.Name
            setCtrl = varargin{index+1};
            setappdata(handles.figResult, varargin{index}, setCtrl);
        case CADLIVE_SetParamO.Name
            setParam = varargin{index+1};
            setappdata(handles.figResult, varargin{index}, setParam);
        case 'Parameter'
            Parameter = varargin{index+1};
            setappdata(handles.figResult, varargin{index}, Parameter);                
        end
    end
    
    % Ot֌W
    if strcmpi(setCtrl.AnalysisType, CADLIVE_SetCtrlO.DynamicAnalysis )
        set( handles.btnGraph, 'Enable', 'on' );
        set( handles.btnEditGraph, 'Enable', 'on' );
        set( handles.btnGraphReset, 'Enable', 'on' );
        if CADLIVE_Tools.isExistFile(CADLIVE_Constant.DISP_FIGURE_FILE) == false
            % JgfBNgɃOt\pXNvgꍇ̓Rs[
            SANAC_HOME = getenv('SANAC_HOME');
            figPath = strcat(SANAC_HOME, '\', CADLIVE_Constant.DISP_FIGURE_FILE);
            copyfile( figPath, '.\' );
            fprintf('Output %s.\n',CADLIVE_Constant.DISP_FIGURE_FILE);
        end
    else
        set( handles.btnGraph, 'Enable', 'off' );
        set( handles.btnEditGraph, 'Enable', 'off' );
        set( handles.btnGraphReset, 'Enable', 'off' );
    end
    
    % Show Make_S_Param Result{^
    if CADLIVE_Tools.isExistFile(CADLIVE_Constant.S_PARAM_FILE) 
        set( handles.btnShowMakeSParam, 'Enable', 'on' );
    else
        set( handles.btnShowMakeSParam, 'Enable', 'off' );
    end
    
    % Show Eigen Values{^(ŗLltB[hꍇ͖)
    if isfield(setParam.SimResult, 'Eigen') == true
        set( handles.btnShowEigenValues, 'Enable', 'on' );
    else
        set( handles.btnShowEigenValues, 'Enable', 'off' );
    end
    
    lenSimResult = length(setParam.SimResult);
    
    % PARAMETER SURVEYR{̐ݒ
    CADLIVE_DispResultU.initParamSurvey(handles, setCtrl, lenSimResult);
    
    % \Rg[̐ݒ
    if setCtrl.SolverType < 10 
        set( handles.txtResult2, 'Visible', 'off' );
        set( handles.tblResult2, 'Visible', 'off' );
        set( handles.tblResult, 'Position', [ 2.1666666666666665 0.8333333333333333 122.5 20.916666666666664 ] );
    
        set( handles.btnQMPS, 'Visible', 'on' ); % add
    elseif setCtrl.SolverType == setCtrl.SolTypeSTD
        set( handles.btnQMPS, 'Visible', 'off' ); % add
        if setCtrl.ParamSurvey == 0
            set( handles.txtResult2, 'Visible', 'on' );
            set( handles.tblResult2, 'Visible', 'on' );
            set( handles.tblResult, 'Position', [ 2.1666666666666665 0.8333333333333333 30.166666666666664 19.416666666666664 ] );
        else
            set( handles.txtResult2, 'Visible', 'off' );
            set( handles.tblResult2, 'Visible', 'off' );
            set( handles.tblResult, 'Position', [ 2.1666666666666665 0.8333333333333333 91.16666666666666 19.416666666666664 ] );
        end
    end
    
    % e[u̐ݒ
    CADLIVE_DispResultU.setDataTable( handles, setCtrl, setParam.SimResult(1) );
    
 end
% UIWAIT makes CADLIVE_DispResult wait for user response (see UIRESUME)
% uiwait(handles.figResult);


% --- Outputs from this function are returned to the command line.
function varargout = CADLIVE_DispResult_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in btnClose.
function btnClose_Callback(hObject, eventdata, handles)
% hObject    handle to btnClose (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
	delete(handles.figResult)


% --- Executes on button press in btnGraph.
function btnGraph_Callback(hObject, eventdata, handles)
% hObject    handle to btnGraph (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    setParam = getappdata(handles.figResult, CADLIVE_SetParamO.Name);
    time_step = setParam.SimResult(1).Result_data.time;
    result_y = setParam.SimResult(1).Result_data.y;
    setCtrl = getappdata(handles.figResult, CADLIVE_SetCtrlO.Name);
    
    lenY = length(setCtrl.Y_initData);
    tag = cell(1, lenY);
    for i=1:lenY
        tag(i) = cellstr( setCtrl.Y_initData(i).tag );
    end
    clear CADLIVE_DispFigure;
    CADLIVE_DispFigure( time_step, result_y, tag );

% --- Executes on button press in btnExportCSV.
function btnExportCSV_Callback(hObject, eventdata, handles)
% hObject    handle to btnExportCSV (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    % t@CI_CAO\
    [fname, path, filterindex] = uiputfile( '*.csv', CADLIVE_Messages.SAVE_CSV );
    if filterindex == false 
        return;
    end
    selPath = fullfile(path, fname);

    % CSVo
    setCtrl = getappdata(handles.figResult, CADLIVE_SetCtrlO.Name);
    setParam = getappdata(handles.figResult, CADLIVE_SetParamO.Name);
    CADLIVE_DispResultU.exportCSV(setCtrl, setParam.SimResult, selPath);

    msgbox( CADLIVE_Messages.COMPLETE_OUTPUT );
    fprintf('Output %s.\n',fname);

% --- Executes on button press in btnExportMatlab.
function btnExportMatlab_Callback(hObject, eventdata, handles)
% hObject    handle to btnExportMatlab (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    % t@CI_CAO\
    [fname, path, filterindex] = uiputfile( '*.mat', CADLIVE_Messages.SAVE_MATLAB );
    if filterindex == false 
        return;
    end
    selPath = fullfile(path, fname);
    
    % ϐl̕ۑ
    setCtrl = getappdata(handles.figResult, CADLIVE_SetCtrlO.Name);
    setParam = getappdata(handles.figResult, CADLIVE_SetParamO.Name);
    CADLIVE_DispResultU.exportMatlab(setCtrl, setParam.SimResult, selPath);
    
    msgbox( CADLIVE_Messages.COMPLETE_OUTPUT );
    fprintf('Output %s.\n',fname);


% --- Executes on button press in btnEditGraph.
function btnEditGraph_Callback(hObject, eventdata, handles)
% hObject    handle to btnEditGraph (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    edit('CADLIVE_DispFigure.m');


% --- Executes on selection change in cmbParamSurveyNo.
function cmbParamSurveyNo_Callback(hObject, eventdata, handles)
% hObject    handle to cmbParamSurveyNo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns cmbParamSurveyNo contents as cell array
%        contents{get(hObject,'Value')} returns selected item from cmbParamSurveyNo
    selParamSurvey = CADLIVE_DispResultU.getSelParamSurveyNo(handles.cmbParamSurveyNo);

    setCtrl = getappdata(handles.figResult, CADLIVE_SetCtrlO.Name);
    setParam = getappdata(handles.figResult, CADLIVE_SetParamO.Name);
    CADLIVE_DispResultU.setDataTable( handles, setCtrl, setParam.SimResult(selParamSurvey) );


% --- Executes during object creation, after setting all properties.
function cmbParamSurveyNo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cmbParamSurveyNo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnShowEigenValues.
function btnShowEigenValues_Callback(hObject, eventdata, handles)
% hObject    handle to btnShowEigenValues (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    
    CADLIVE_DispEigenValues( ...
        CADLIVE_SetParamO.Name ...
        , getappdata(handles.figResult, CADLIVE_SetParamO.Name) ...
    );


% --- Executes on button press in btnShowMakeSParam.
function btnShowMakeSParam_Callback(hObject, eventdata, handles)
% hObject    handle to btnShowMakeSParam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    CADLIVE_DispMakeSParam();

    
% --- Executes on button press in btnGraphReset.
function btnGraphReset_Callback(hObject, eventdata, handles)
% hObject    handle to btnGraphReset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    result = questdlg( ...
        CADLIVE_Messages.CONFIRM_SCRIPT_RESET ...
        , CADLIVE_Messages.CONFIRM ...
        , CADLIVE_Messages.YES ...
        , CADLIVE_Messages.NO ...
        , CADLIVE_Messages.NO ...
        );
    if strcmpi( result, CADLIVE_Messages.NO )
        return;
    end
    
    % ㏑Rs[
    if CADLIVE_Tools.isExistFile(CADLIVE_Constant.DISP_FIGURE_FILE) 
        delete(CADLIVE_Constant.DISP_FIGURE_FILE);
    end
    SANAC_HOME = getenv('SANAC_HOME');
    figPath = strcat(SANAC_HOME, '\', CADLIVE_Constant.DISP_FIGURE_FILE);
    [status, message] = copyfile( figPath, '.\' );
    if status == 0
        msgbox( message );
    end


% added by inoue
% --- Executes on button press in btnSaveforInput.
function btnSaveforInput_Callback(hObject, eventdata, handles)
% hObject    handle to btnSaveforInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
setCtrl = getappdata(handles.figResult, CADLIVE_SetCtrlO.Name);
setParam = getappdata(handles.figResult, CADLIVE_SetParamO.Name);

lenY = length(setCtrl.Y_initData);
for i=1:lenY
    setCtrl.Y_initData(i).value = setParam.SimResult(1).Y(i) ;
end
setCtrl.saveInitial( 'CADLIVE_saveInitial' );
msgbox( 'Save final values as initial values (CADLIVE_saveInitial.m).' );
fprintf('Output CADLIVE_saveInital.m.\n');

% added by inoue
% --- Executes on button press in btnQMPS.
function btnQMPS_Callback(hObject, eventdata, handles)
% hObject    handle to btnQMPS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    CADLIVE_SetQMPS( ...
        CADLIVE_SetParamO.Name, getappdata(handles.figResult, CADLIVE_SetParamO.Name) ...
        , 'Parameter', getappdata(handles.figResult, 'Parameter') ...
    );


    
    
    
