function varargout = CADLIVE_DispResultS(varargin)
% CADLIVE_DISPRESULTS M-file for CADLIVE_DispResultS.fig
%      CADLIVE_DISPRESULTS, by itself, creates a new CADLIVE_DISPRESULTS or raises the existing
%      singleton*.
%
%      H = CADLIVE_DISPRESULTS returns the handle to a new CADLIVE_DISPRESULTS or the handle to
%      the existing singleton*.
%
%      CADLIVE_DISPRESULTS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CADLIVE_DISPRESULTS.M with the given input arguments.
%
%      CADLIVE_DISPRESULTS('Property','Value',...) creates a new CADLIVE_DISPRESULTS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CADLIVE_DispResultS_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CADLIVE_DispResultS_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CADLIVE_DispResultS

% Last Modified by GUIDE v2.5 14-Jun-2012 08:51:05

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CADLIVE_DispResultS_OpeningFcn, ...
                   'gui_OutputFcn',  @CADLIVE_DispResultS_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CADLIVE_DispResultS is made visible.
function CADLIVE_DispResultS_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CADLIVE_DispResultS (see VARARGIN)

% Choose default command line output for CADLIVE_DispResultS
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

if(nargin > 3)
    for index = 1:2:(nargin-3),
        switch varargin{index}
        case CADLIVE_SelectChemO.Name
            selectChemO = varargin{index+1};
            setappdata(handles.figResultS, varargin{index}, selectChemO);
        case CADLIVE_EditUsrFuncO.Name
            editUsrFuncO = varargin{index+1};
            setappdata(handles.figResultS, varargin{index}, editUsrFuncO);
        case CADLIVE_SetCtrlO.Name
            setCtrl = varargin{index+1};
            setappdata(handles.figResultS, varargin{index}, setCtrl);
        case CADLIVE_SetParamO.Name
            setParam = varargin{index+1};
            setappdata(handles.figResultS, varargin{index}, setParam);
        end
    end
    
    % Show Eigen Values{^(ŗLltB[hꍇ͖)
    if isfield(setParam.SimResult, 'Eigen') == true
        set( handles.btnShowEigenValues, 'Enable', 'on' );
    else
        set( handles.btnShowEigenValues, 'Enable', 'off' );
    end
    
    lenSimResult = length(setParam.SimResult);
    
    % PARAMETER SURVEYR{̐ݒ
    CADLIVE_DispResultU.initParamSurvey(handles, setCtrl, lenSimResult);
    
    % e[u̐ݒ
    CADLIVE_DispResultU.setDataTableS( handles, setCtrl, setParam.SimResult(1) );
 end
% UIWAIT makes CADLIVE_DispResultS wait for user response (see UIRESUME)
% uiwait(handles.figResultS);


% --- Outputs from this function are returned to the command line.
function varargout = CADLIVE_DispResultS_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in btnExportCSV.
function btnExportCSV_Callback(hObject, eventdata, handles)
% hObject    handle to btnExportCSV (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    % t@CI_CAO\
    [fname, path, filterindex] = uiputfile( '*.csv', CADLIVE_Messages.SAVE_CSV );
    if filterindex == false 
        return;
    end
    selPath = fullfile(path, fname);

    % CSVo
    setCtrl = getappdata(handles.figResultS, CADLIVE_SetCtrlO.Name);
    setParam = getappdata(handles.figResultS, CADLIVE_SetParamO.Name);
    CADLIVE_DispResultU.exportCSV(setCtrl, setParam.SimResult, selPath);

    msgbox( CADLIVE_Messages.COMPLETE_OUTPUT );


% --- Executes on button press in btnExportMatlab.
function btnExportMatlab_Callback(hObject, eventdata, handles)
% hObject    handle to btnExportMatlab (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    % t@CI_CAO\
    [fname, path, filterindex] = uiputfile( '*.mat', CADLIVE_Messages.SAVE_MATLAB );
    if filterindex == false 
        return;
    end
    selPath = fullfile(path, fname);
    
    % ϐl̕ۑ
    setCtrl = getappdata(handles.figResultS, CADLIVE_SetCtrlO.Name);
    setParam = getappdata(handles.figResultS, CADLIVE_SetParamO.Name);
    CADLIVE_DispResultU.exportMatlab(setCtrl, setParam.SimResult, selPath);
    
    msgbox( CADLIVE_Messages.COMPLETE_OUTPUT );

% --- Executes on button press in btnClose.
function btnClose_Callback(hObject, eventdata, handles)
% hObject    handle to btnClose (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
	delete(handles.figResultS)

% --- Executes on selection change in cmbParamSurveyNo.
function cmbParamSurveyNo_Callback(hObject, eventdata, handles)
% hObject    handle to cmbParamSurveyNo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns cmbParamSurveyNo contents as cell array
%        contents{get(hObject,'Value')} returns selected item from cmbParamSurveyNo
    selParamSurvey = CADLIVE_DispResultU.getSelParamSurveyNo(handles.cmbParamSurveyNo);

    setCtrl = getappdata(handles.figResult, CADLIVE_SetCtrlO.Name);
    setParam = getappdata(handles.figResult, CADLIVE_SetParamO.Name);
    CADLIVE_DispResultU.setDataTableS( handles, setCtrl, setParam.SimResult(selParamSurvey) );


% --- Executes during object creation, after setting all properties.
function cmbParamSurveyNo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cmbParamSurveyNo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnShowEigenValues.
function btnShowEigenValues_Callback(hObject, eventdata, handles)
% hObject    handle to btnShowEigenValues (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    
    CADLIVE_DispEigenValues( ...
        CADLIVE_SetParamO.Name ...
        , getappdata(handles.figResultS, CADLIVE_SetParamO.Name) ...
    );
