classdef CADLIVE_DispResultU
    %CADLIVE_DISPRESULTU CADLIVE_DISPRESULT̃[eBeBNX
    
    methods(Static)

        function initParamSurvey(handles, setCtrl, lenSimResult)
            % initParamSurvey PARAMETER SURVEYR{̐ݒ
            
            if setCtrl.ParamSurvey == 1
                prmSurvey = cell(lenSimResult);
                for i=1:1:lenSimResult
                    prmSurvey(i) = cellstr(num2str(i));
                end
                set( handles.txtParamSurvey, 'Enable', 'on' );
                set( handles.cmbParamSurveyNo, 'Enable', 'on' );
                set(handles.cmbParamSurveyNo,'String', prmSurvey);
            else
                set( handles.txtParamSurvey, 'Enable', 'off' );
                set( handles.cmbParamSurveyNo, 'Enable', 'off' );
            end
        end
        
        function selParamSurveyNo = getSelParamSurveyNo(cmbParamSurveyNo)
            val = get(cmbParamSurveyNo,'Value');
            string_list = get(cmbParamSurveyNo,'String');
            selParamSurveyNo = str2num(string_list{val}); 
        end
        
        function setDataTable( handles, setCtrl, simResult )
            % setDataTable V~[V̌ʂe[uɐݒ

            if simResult.Result == false
                return;
            end
            if setCtrl.SolverType < 10
                % ԓWJ
                CADLIVE_DispResultU.setDataTableForDynamicAnalysis( handles, setCtrl, simResult );

            elseif setCtrl.SolverType == setCtrl.SolTypeSTD
                % 
                CADLIVE_DispResultU.setDataTableForSTDbyNR( handles, setCtrl, simResult );

            end
        end

        function setDataTableS( handles, setCtrl, simResult )
            % setDataTableS S-System̃V~[V̌ʂe[uɐݒ

            if simResult.Result == false
                return;
            end
            
            CADLIVE_DispResultU.setDataTableForSTDValueFlux( handles, simResult );
            
            if ~isempty(simResult.Result_data.LogGainMetabo)
            CADLIVE_DispResultU.setDataTableForLogGain( ...
                handles.tblLogGainMetabo ...
                , simResult.Result_data.LogGainMetabo ...
                , true ...
            );
            CADLIVE_DispResultU.setDataTableForLogGain( ...
                handles.tblLogGainFlux ...
                , simResult.Result_data.LogGainsFlux ...
                , false ...
            );
            end
        
            CADLIVE_DispResultU.setDataTableForSensRate( ...
                handles.tblSensMetaboRate ...
                , simResult.Result_data.SensMetaboRateConst ...
                , true ...
            );
            CADLIVE_DispResultU.setDataTableForSensRate( ...
                handles.tblSensFluxRate ...
                , simResult.Result_data.SensFluxRateConst ...
                , false ...
            );

            CADLIVE_DispResultU.setDataTableForSensOrder( ...
                handles.tblSensMetaboOrder ...
                , simResult.Result_data.SensMetaboKinOrder ...
                , true ...
            );
            CADLIVE_DispResultU.setDataTableForSensOrder( ...
                handles.tblSensFluxOrder ...
                , simResult.Result_data.SensFluxKinOrder ...
                , false ...
            );
        end
        
        function setDataTableForDynamicAnalysis( handles, setCtrl, simResult )
            % setDataTableForDynamicAnalysis ԓWJ̌ʏo

            time_step = simResult.Result_data.time;
            result_y = simResult.Result_data.y;
            [rows, cols] = size(result_y);
            colsName     = cell(1, cols);
            colsFormat   = cell(1, cols);
            colsEditable = false(1, cols);
            for j=1:1:cols
                colsName(j) = cellstr(sprintf('y[%d].%s', j, setCtrl.Y_initData(j).tag ));
                colsFormat(j) = cellstr('numeric');
            end
            rowsName = cell(1, rows);
            for j=1:1:rows
                rowsName(j) = cellstr( sprintf('%10.3E', time_step(j)) );
            end
            set( handles.tblResult, 'ColumnName', colsName );
            set( handles.tblResult, 'ColumnFormat', colsFormat );
            set( handles.tblResult, 'ColumnEditable', colsEditable );
            set( handles.tblResult, 'RowName', rowsName );
            set( handles.tblResult, 'Data', result_y );
        end
        
        function setDataTableForSTDbyNR( handles, setCtrl, simResult )
            % setDataTableForSTDbyNR ̌ʏo

            y = simResult.Y;
            colsName = {'y value'};
            colsFormat = {'numeric'};
            colsEditable = false(1,1);

            rows = length(y);
            rowsName = cell(1, rows);
            for j=1:1:rows
                rowsName(j) = cellstr( sprintf('%d', j) );
            end
            set( handles.tblResult, 'ColumnName', colsName );
            set( handles.tblResult, 'ColumnFormat', colsFormat );
            set( handles.tblResult, 'ColumnEditable', colsEditable );
            set( handles.tblResult, 'RowName', rowsName );
            set( handles.tblResult, 'Data', y );

            if setCtrl.ParamSurvey == 0
                % Sensitivity
                CADLIVE_DispResultU.setDataTableForSensivity(handles, setCtrl, simResult.Result_data.sensitivity);
            end
        end
        
        function setDataTableForSensivity( handles, setCtrl, sensivity )
            % setDataTableForSensivity Sensivity̏o

            sensFields = fields(sensivity);
            lenFields = length(sensFields);
            [rows, cols] = size(sensivity.(char(sensFields(1))));
            cols = cols+1;

            % ݒ
            colsName     = cell(1, cols);
            colsFormat   = cell(1, cols);
            colsEditable = false(1, cols);
            
            colsName(1) = cellstr('');
            colsFormat(1) = cellstr('char');
            for j=2:1:cols
                colsName(j) = cellstr(sprintf('y[%d].%s', j-1, setCtrl.Y_initData(j-1).tag ));
                colsFormat(j) = cellstr('numeric');
            end

            % etB[h̃f[^擾
            rows = 1;
            for i=1:1:lenFields
                fname = char(sensFields(i));

                [r, c] = size(sensivity.(fname));
                for j=1:1:r
                    rowsName(rows) = cellstr(sprintf('%d', rows));
                    senseData{rows,1} = sprintf('%s(%d)', fname, j);
                    for k=1:1:c
                        senseData{rows,k+1} = sensivity.(fname)(j,k);
                    end
                    rows = rows + 1;
                end
            end

            set( handles.tblResult2, 'ColumnName', colsName );
            set( handles.tblResult2, 'ColumnFormat', colsFormat );
            set( handles.tblResult2, 'ColumnEditable', colsEditable );
            set( handles.tblResult2, 'RowName', rowsName );
            set( handles.tblResult2, 'Data', senseData );
        end
        
        function setDataTableForSTDValueFlux( handles, simResult )
            % setDataTableForSTDValueFlux STD Values and Fluxešʏo

            result = simResult.Result_data.STDValueFlux;
            rows = length(result);
            cols = 3;
            
            result_data = cell( rows, cols );
            for i=1:1:rows
                result_data(i,:) = { ...
                    result(i).value ...
                    , result(i).Flux ...
                    , result(i).tag ...
                };
            end

            colsName     = {'STD value', 'Flux', 'Tag'};
            colsFormat   = {'numeric', 'numeric', 'char'};
            colsEditable = false(1, cols);
            
            rowsName = cell(1, rows);
            for j=1:1:rows
                rowsName(j) = cellstr( num2str(j) );
            end
            set( handles.tblStdValueFlux, 'ColumnName', colsName );
            set( handles.tblStdValueFlux, 'ColumnFormat', colsFormat );
            set( handles.tblStdValueFlux, 'ColumnEditable', colsEditable );
            set( handles.tblStdValueFlux, 'RowName', rowsName );
            set( handles.tblStdValueFlux, 'Data', result_data );
        end
        
        function setDataTableForLogGain( figure, logGain, isMetabo )
            % setDataTableForLogGain Logarythmic Gains of xxxxx ̌ʏo

            %[rows, cols] = size(logGain(1).constantPlayer);
			rows = length(logGain);
			cols = length(logGain(1).constantPlayer);
			
            colPre = 'y';
            if isMetabo == false 
                colPre = 'v';
            end
            
            colsName     = cell(1, cols);
            colsFormat   = cell(1, cols);
            colsEditable = false(1, cols);
            for i=1:1:cols
                colsName(i) = cellstr( sprintf( '%s[%d]', colPre, i ));
                colsFormat(i) = cellstr('numeric');
            end
            
            rowsName = cell(1, rows);
            for i=1:1:rows
                rowsName(i) = cellstr( sprintf('constantPlayer[%d]', i) );
                for j=1:1:cols
                    result_data(i,j) = logGain(i).constantPlayer(j);
                end
            end
            
            set( figure, 'ColumnName', colsName );
            set( figure, 'ColumnFormat', colsFormat );
            set( figure, 'ColumnEditable', colsEditable );
            set( figure, 'RowName', rowsName );
            %set( figure, 'Data', logGain.constantPlayer );
            set( figure, 'Data', result_data );
        end
                
        function setDataTableForSensRate( figure, sensRate, isMetabo )
            % setDataTableForSensRate Sensitivities of xxx with respect to rate constants ̌ʏo

            rows = length(sensRate);
            cols = length(sensRate(1).alpha);
            
            colPre = 'y';
            if isMetabo == false 
                colPre = 'v';
            end
            
            colsName     = cell(1, cols);
            colsFormat   = cell(1, cols);
            colsEditable = false(1, cols);
            for i=1:1:cols
                colsName(i) = cellstr( sprintf( '%s[%d]', colPre, i ));
                colsFormat(i) = cellstr('numeric');
            end
            
            rowsName = cell(1, rows);
            result_data = zeros(rows, cols);
            for i=1:1:rows
                rowsName(i) = cellstr( sprintf('alpha[%d]', i) );
                for j=1:1:cols
                    result_data(i,j) = sensRate(i).alpha(j);
                end
            end
            
            set( figure, 'ColumnName', colsName );
            set( figure, 'ColumnFormat', colsFormat );
            set( figure, 'ColumnEditable', colsEditable );
            set( figure, 'RowName', rowsName );
            set( figure, 'Data', result_data );
         end
        
        function setDataTableForSensOrder( figure, sensOrder, isMetabo )
            % setDataTableForSensOrder Sensitivities of xxx with respect to kinetic orders ̌ʏo

            [rows_g, cols_g] = size(sensOrder.g);
            [rows_h, cols_h] = size(sensOrder.h);
            rows = rows_g + rows_h;
            cols = cols_g;
            
            colPre = 'y';
            if isMetabo == false 
                colPre = 'v';
            end
            
            colsName     = cell(1, cols);
            colsFormat   = cell(1, cols);
            colsEditable = false(1, cols);
            for i=1:1:cols
                colsName(i) = cellstr( sprintf( '%s[%d]', colPre, i ));
                colsFormat(i) = cellstr('numeric');
            end
            
            rowsName = cell(1, rows);
            result_data = zeros(rows, cols);
            for i=1:1:rows_g
                rowsName(i) = cellstr( sprintf('g[%d]', i) );
                for j=1:1:cols
                    result_data(i,j) = sensOrder.g(i,j);
                end
            end
            for i=1:1:rows_h
                rowsName(i+rows_g) = cellstr( sprintf('h[%d]', i) );
                for j=1:1:cols
                    result_data(i+rows_g,j) = sensOrder.h(i,j);
                end
            end
            
            set( figure, 'ColumnName', colsName );
            set( figure, 'ColumnFormat', colsFormat );
            set( figure, 'ColumnEditable', colsEditable );
            set( figure, 'RowName', rowsName );
            set( figure, 'Data', result_data );
        end
         
        function exportMatlab(setCtrl, simResult, selPath)
            % exportMatlab MATLAB`Ńf[^o͂
            
            lenSimResult = length(simResult);
            for i=1:1:lenSimResult
                if simResult(i).Result == false
                    continue;
                end
                % sʂ̏o
                if setCtrl.SolverType < 10
                    tmp(i).TimeStep = simResult(i).Result_data.time;
                    tmp(i).y        = simResult(i).Result_data.y;
                    
                    lenY = length(setCtrl.Y_initData);
                    tmp(i).tag     = cell(1, lenY);
                    for j=1:1:lenY
                        tmp(i).tag(j) = cellstr(setCtrl.Y_initData(j).tag);
                    end
                elseif setCtrl.SolverType == setCtrl.SolTypeSTD
                    tmp(i).y = simResult(i).Y;
                    
                    lenY = length(setCtrl.Y_initData);
                    tmp(i).tag     = cell(1, lenY);
                    for j=1:1:lenY
                        tmp(i).tag(j) = cellstr(setCtrl.Y_initData(j).tag);
                    end
                    
                    if isfield( simResult(i).Result_data, 'sensitivity' )
                        tmp(i).Sensitivity = simResult(i).Result_data.sensitivity;
                    end
                elseif setCtrl.SolverType == setCtrl.SolTypeSSystem
                    tmp(i).STDValueFlux        = simResult(i).Result_data.STDValueFlux;
                    tmp(i).LogGainMetabo       = simResult(i).Result_data.LogGainMetabo;
                    tmp(i).SensMetaboRateConst = simResult(i).Result_data.SensMetaboRateConst;
                    tmp(i).SensMetaboKinOrder  = simResult(i).Result_data.SensMetaboKinOrder;
                    tmp(i).LogGainsFlux        = simResult(i).Result_data.LogGainsFlux;
                    tmp(i).SensFluxRateConst   = simResult(i).Result_data.SensFluxRateConst;
                    tmp(i).SensFluxKinOrder    = simResult(i).Result_data.SensFluxKinOrder;
                end

                % ŗLl̏o
                if isfield( simResult(i), 'Eigen' )
                    tmp(i).Eigen = simResult(i).Eigen;
                end
            end

            save( selPath, '-struct', 'tmp' );
        end
        
        function exportCSV(setCtrl, simResult, selPath)
            fp_out = fopen(selPath,'w');
            
            % exportMatlab MATLAB`Ńf[^o͂
            lenSimResult = length(simResult);
            for i=1:1:lenSimResult
                if simResult(i).Result == false
                    continue;
                end
                if setCtrl.ParamSurvey == 1
                    fprintf( fp_out,'##### Parameter Survey : %d data sets.\n\n', i );
                    fprintf( fp_out, '$$ PARAMETER SURVEY No. %d : \n\n', i );
                end
                
                % sʂ̏o
                if setCtrl.SolverType < 10
                    % ԓWJ
                    CADLIVE_DispResultU.exportCSVForDynamicAnalysis(setCtrl, simResult(i).Result_data, fp_out);
                elseif setCtrl.SolverType == setCtrl.SolTypeSTD
                    % 
                    CADLIVE_DispResultU.exportCSVForSTDbyNR(simResult(i).Y, simResult(i).Result_data, fp_out);
                elseif setCtrl.SolverType == setCtrl.SolTypeSSystem
                    % S-System
                    CADLIVE_DispResultU.exportCSVForSSystemSTD(simResult(i).Result_data, fp_out);
                end

                % ŗLl̏o
                if isfield( simResult(i), 'Eigen' )
                    eigen = simResult(i).Eigen;
                    fprintf( fp_out, '\n$$ Eigenvalues');
                    if setCtrl.SolverType < 10
                        fprintf( fp_out, ' (calc. with last y values)\n');
                    else
                        fprintf( fp_out, '\n' );
                    end

                    % wb_o
                    fprintf( fp_out, '  No.,        Real,   Imaginary\n' );

                     % f[^{̏o
                   lenEigen = length(eigen);
                    for j=1:1:lenEigen 
                        fprintf( fp_out, '%5d,%12.3E,%12.3E\n', j, real(eigen(j)), imag(eigen(j)) );
                    end
                end
            end
            fclose(fp_out);
        end
        
        function exportCSVForDynamicAnalysis(setCtrl, result_data, fp_out)
            
            time_step = result_data.time;
            result_y = result_data.y;
            [rows, cols] = size(result_y);

            % wb_o
            fprintf( fp_out, '%-10s', 'time' );
            for c=1:1:cols
                %fprintf( fp_out, ',     y[%3d]', c );
                fprintf( fp_out, ',%11s', setCtrl.Y_initData(c).tag );
            end
            fprintf( fp_out, '\n' );
            % f[^{̏o
            for r=1:1:rows
                fprintf( fp_out, '%10.3E', time_step(r) );
                for c=1:1:cols
                    fprintf( fp_out, ', %10.3E', result_y(r,c) );
                end
                fprintf( fp_out, '\n' );
            end
        end
        
        function exportCSVForSTDbyNR(y, result_data, fp_out)
            rows = length(y);

            % Y̒lo
            fprintf( fp_out, 'index,     y value\n' );
            for r=1:1:rows
                fprintf( fp_out, '%5d,%12.4e\n', r, y(r) );
            end

            if isfield( result_data, 'sensitivity' )
                fprintf( fp_out, '\n$$ Sensitivity\n' );
                sensitivity = result_data.sensitivity;

                % eϐƂɏo
                fNames = fields(sensitivity);
                lenFields = length(fNames);
                for fi=1:1:lenFields
                    pData = sensitivity.(char(fNames(fi)));
                    [rows, cols] = size(pData);
                    for r=1:1:rows
                        tmp = sprintf( '%s[%3d]', char(fNames(fi)), r );
                        fprintf( fp_out, '%4d: %-12s', fi*r, tmp );
                        for c=1:1:cols
                            fprintf( fp_out, ', %12.3E,', pData(r,c) );
                        end
                        fprintf( fp_out, '\n' );
                    end
                end
            end

        end
        
        function exportCSVForSSystemSTD(result_data, fp_out)
            rows = length(result_data.STDValueFlux);

            fprintf( fp_out, '$ STD Values and Fluxes $\n' );
            fprintf( fp_out, 'index,  STD value ,      Flux\n' );
            for r=1:1:rows
                fprintf( fp_out, '%5d,%12.3e,%12.3e, #%s\n' ...
                    , r ...
                    , result_data.STDValueFlux(r).value ...
                    , result_data.STDValueFlux(r).Flux ...
                    , result_data.STDValueFlux(r).tag ...
                    );
            end

            CADLIVE_DispResultU.exportCSVForLogarythmicGains( ...
                'Logarythmic Gains of Metabolites' ...
                , result_data.LogGainMetabo ...
                , true ...
                , fp_out ...
            );

            CADLIVE_DispResultU.exportCSVForSensRate( ...
                'Sensitivities of Metabolites with respect to rate constants' ...
                , result_data.SensMetaboRateConst ...
                , true ...
                , fp_out ...
            );

            CADLIVE_DispResultU.exportCSVForSensOrder( ...
                'Sensitivities of Metabolites with respect to kinetic orders' ...
                , result_data.SensMetaboKinOrder ...
                , false ...
                , fp_out ...
            );
            
            CADLIVE_DispResultU.exportCSVForLogarythmicGains( ...
                'Logarythmic Gains of Fluxes' ...
                , result_data.LogGainsFlux ...
                , false ...
                , fp_out ...
            );

            CADLIVE_DispResultU.exportCSVForSensRate( ...
                'Sensitivities of Fluxes with respect to rate constants' ...
                , result_data.SensFluxRateConst ...
                , false ...
                , fp_out ...
            );

            CADLIVE_DispResultU.exportCSVForSensOrder( ...
                'Sensitivities of Fluxes with respect to kinetic orders' ...
                , result_data.SensFluxKinOrder ...
                , false ...
                , fp_out ...
            );
        end
        
        function exportCSVForLogarythmicGains(header, data, isMetabo, fp_out)
            %[rows, cols] = size(data.constantPlayer);
            rows = length(data);
            cols = length(data(1).constantPlayer);

            % wb_o
            fprintf( fp_out, '\n$ %s $\n', header );
            fprintf( fp_out, '%-19s','param/var' );
            label = 'y';
            if isMetabo == false
                label = 'v';
            end
            for c=1:1:cols
                fprintf( fp_out, ',     %s[%3d]', label,c );
            end
            fprintf( fp_out, '\n' );
            % f[^{̏o
            for r=1:1:rows
                fprintf( fp_out, '%14s[%3d]', 'constantPlayer', r );
                for c=1:1:cols
                    fprintf( fp_out, ',%11.3e', data(r).constantPlayer(c) );
                end
                fprintf( fp_out, '\n' );
            end
        end
    
        function exportCSVForSensRate(header, data, isMetabo, fp_out)
            rows = length(data);
            cols = length(data(1).alpha);
            
            % wb_o
            fprintf( fp_out, '\n$ %s $\n', header );
            fprintf( fp_out, '%-19s', 'param/var' );
            label = 'y';
            if isMetabo == false
                label = 'v';
            end
            for c=1:1:cols
                fprintf( fp_out, ',     %s[%3d]', label,c );
            end
            fprintf( fp_out, '\n' );
            % f[^{̏o
            for r=1:1:rows
                fprintf( fp_out, '%14s[%3d]', 'alpha', r );
                for c=1:1:cols
                    fprintf( fp_out, ',%11.3e', data(r).alpha(c) );
                end
                fprintf( fp_out, '\n' );
            end
        end
        
        function exportCSVForSensOrder(header, data, isMetabo, fp_out)
            [rows_g, cols_g] = size(data.g);
            [rows_h, cols_h] = size(data.h);
            cols = cols_g;
            
            % wb_o
            fprintf( fp_out, '\n$ %s $\n', header );
            fprintf( fp_out, '%-19s', 'param/var' );
            label = 'y';
            if isMetabo == false
                label = 'v';
            end
            for c=1:1:cols
                fprintf( fp_out, ',     %s[%3d]', label, c );
            end
            fprintf( fp_out, '\n' );
            % f[^{̏o
            for r=1:1:rows_g
                fprintf( fp_out, '%14s[%3d]', 'g', r );
                for c=1:1:cols
                    fprintf( fp_out, ',%11.3e', data.g(r,c) );
                end
                fprintf( fp_out, '\n' );
            end
            for r=1:1:rows_h
                fprintf( fp_out, '%14s[%3d]', 'h', r );
                for c=1:1:cols
                    fprintf( fp_out, ',%11.3e', data.h(r,c) );
                end
                fprintf( fp_out, '\n' );
            end
        end
    end
end

