classdef CADLIVE_DoSolver < handle
    %CADLIVE_DOSOLVER \osNX
    %   ڍאɋLq
    
    properties(Access=protected)
        Ctrl;
        ParamP;
        Events;
        InitY;
    end
    
    properties(Access=public)
        Param;
        ParamT;
    end
    
    methods
         function obj = CADLIVE_DoSolver(ctrl, param, paramT, paramP, events, initY )
            % RXgN^
            obj.Ctrl = ctrl;
            obj.Param = param;
            obj.ParamT = paramT;
            obj.ParamP = paramP;
            obj.Events = events;
            obj.InitY = initY;
         end
         
        function [ result, res_data, y, y_pre ] = DoSolver( obj, y_start, y, y_pre )
            
            res_data = [];
            if obj.Ctrl.SOLVER < 10
                % Cxg̐ݒ
                lenEvent = length(obj.Events);
                for i=1:1:lenEvent
                    if strcmp( obj.Events(i).name, CADLIVE_Constant.CONST_PLAYER ) ...
                            || strcmp( obj.Events(i).name, CADLIVE_Constant.Y_ADD ) ...
                            || strcmp( obj.Events(i).name, CADLIVE_Constant.Y_FORCE )
                        obj.Events(i).value = obj.Events(i).value * obj.Ctrl.G_VALUE;
                    elseif strcmp( obj.Events(i).name, CADLIVE_Constant.TIME_START )
                        obj.Events(i).time = obj.Ctrl.T_START;
                    elseif strcmp( obj.Events(i).name, CADLIVE_Constant.TIME_END )
                        obj.Events(i).time = obj.Ctrl.T_END;
                    end
                end
                if obj.Ctrl.SOLVER == 2
                    diffEqAdaptive = CADLIVE_ode45( obj.Ctrl, obj.Param, obj.ParamT, obj.ParamP );
                    [result, res_data.time, res_data.y, y, y_pre] = diffEqAdaptive.doSolver( y_start, obj.Events );
                    
                elseif obj.Ctrl.SOLVER == 3
                    % NDF
                    ndf_sol = CADLIVE_ode15s( obj.Ctrl, obj.Param, obj.ParamT, obj.ParamP );
                    [result, res_data.time, res_data.y, y, y_pre] = ndf_sol.doSolver( y_start, obj.Events );
                end
            else 
                if obj.Ctrl.SOLVER == 11 
                    % ̏ꍇ

                    % \os
                    solNewtonRaphson = CADLIVE_NewtonRaphson(obj.Ctrl, obj.Param, obj.ParamT, obj.ParamP);
                    [result, y, y_pre, res_data.sensitivity] = solNewtonRaphson.SolveSTDbyNR(y, y_pre);
                    if result == false
                        return;
                    end

                elseif obj.Ctrl.SOLVER == 12
                    % S-System̒
                    solSSystem= CADLIVE_SsysSTD(obj.Ctrl, obj.Param, obj.ParamT, obj.ParamP, obj.InitY);
                    [result, y] = solSSystem.SsysSTD(y);
                    if result == true
                        % ʂ\̂Ɉڂւ
                        res_data.STDValueFlux = solSSystem.STDValueFlux;
                        res_data.LogGainMetabo = solSSystem.LogarythmicGainsMetabolites;
                        res_data.SensMetaboRateConst = solSSystem.SensitivitiesMetabolitesRateConstants;
                        res_data.SensMetaboKinOrder = solSSystem.SensitivitiesMetabolitesKineticOrders;
                        res_data.LogGainsFlux = solSSystem.LogarythmicGainsFluxes;
                        res_data.SensFluxRateConst = solSSystem.SensitivitiesFluxesRateConstants;
                        res_data.SensFluxKinOrder = solSSystem.SensitivitiesFluxesKineticOrders;
                        %save(CADLIVE_Constant.S_PARAM_FILE, '-struct', 'res_data');
                    end
                end
            end
        end

   end
    
end

