function [populations, info] = CADLIVE_MGGvariant(populations, searchParam, info)
%info.n_population, info.n_children, info.searchType, info.alpha, info.beta, info.h, info.progressStop

% Minimal Generation Gap Selection for UNDX
% See Hiroaki Kitano, "Genetic Algorithms 4", Sangyo-tosho, p234, 2000 

maxitr = 10;

ip = zeros(1,3);
for i = 1:maxitr
    ip(1)=ceil(rand*info.n_population);
    ip(2)=ceil(rand*info.n_population);
    if ip(1) ~= ip(2)
        break;
    end
end

for i = 1:info.n_children
    for j = 1:maxitr
        ip(3) = ceil(rand*info.n_population);
        if ip(3) ~= ip(1) && ip(3) ~= ip(2)
            break;
        end
    end
    children(i) = CADLIVE_getNewChild(populations(ip(1)), populations(ip(2)), populations(ip(3)), searchParam, info);
    info = CADLIVE_showProgressBar(info);
    if info.progressStop
    	return;
    end
end

children(info.n_children+1) = populations(ip(1));
children(info.n_children+2) = populations(ip(2));
children = CADLIVE_sortPopulations(children);
populations(ip(1)) = children(1);
populations(ip(2)) = children(ceil(rand*(info.n_children+1))+1);
populations = CADLIVE_sortPopulations(populations);

clear children
