classdef CADLIVE_NewtonRaphson < CADLIVE_Solver
    %CADLIVE_NEWTONRAPHSON Newton|Raphson@ŘANX
    %   NewtonRaphson.cppMATLABɈڐA
    
    methods
        function obj = CADLIVE_NewtonRaphson(ctrl, param, paramT, paramP )
            % RXgN^
            obj = obj@CADLIVE_Solver(ctrl, param, paramT, paramP);
        end
        
        function [result, y, y_pre, sense] = SolveSTDbyNR(obj, y, y_pre)
            % Newton|Raphson@ŘAB
            sense=false;
            [res, y] = obj.SetNRparam(y);
            if res == false 
                % Qߏsꍇ
                obj.Param = obj.ParamP;
                % y̒lO̒lɖ߂Ă
                y = y_pre;
                result = false;
                %fprintf('error.;SetNRparam\n');
                return;
            end
            obj.Param = obj.ParamT;
            
            % ēxmȃp[^̒lŉ
            [res, y] = obj.checkNRresult(y);
            if res == false
                % ܂ȂA܂͕̉܂ꍇ
                obj.Param = obj.ParamP;
                % y̒lO̒lɖ߂Ă
                y = y_pre;
                result = false;
                %fprintf('error.;checkNRresult\n');
                return;
            end
            
            % ̂߂Ɍ݂̒lParamPAy_preɊi[
            obj.ParamP = obj.Param;
            y_pre = y;
            
            [res, sense] = obj.Sensitivity(y, y_pre);
            result = res;
        end
        
    end
    methods(Access=private)
        function [result, sense] = Sensitivity(obj, y, y_pre)
            pFields = fields(obj.Param);
            lenParam = length(pFields);
            
            %corrected by inoue
            lenY = length(y);
            qmps = zeros(1,lenY);
            for i=1:1:lenParam
                name = char(pFields(i));
                [res, y, var, qmps0] = obj.cal_sens( y , y_pre , name );
                if res == false
                    result = false;
                    return;
                end
                sense.(name) = var;
                if strcmp(name,'constantPlayer')==0
                	qmps=qmps+qmps0;
                end
            end
            sense.QMPS = qmps;
            %%%%%%%%%%%%%%%%%%%%%%%%
            result = true;
        end
    
        function [result, y, var, qmps0] = cal_sens(obj, y, y_pre, name )
            denomi = log(1.0 + obj.CONTROL_DATA.NR_SENS_CW);
            lenY = length(y);
            
            lenP = length(obj.Param.(name));
            var = zeros(lenP, lenY);
            qmps0 = zeros(1,lenY);
            for i=1:1:lenP
                if obj.Param.(name)(i).value ~= 0
                    y = y_pre;
                    delta = obj.Param.(name)(i).value * obj.CONTROL_DATA.NR_SENS_CW;
                    tg = obj.Param.(name)(i).value + delta;
                    
                    [res, y] = obj.changeNRparam( tg, name, i, y );
                    if res == false
                        result = false;
                        return;
                    end
                    
                    for j=1:1:lenY
                        var(i,j) = log( y(j) / y_pre(j) ) / denomi;
                        qmps0(j) = qmps0(j) + var(i,j)^2;
                    end
                    obj.Param.(name)(i) = obj.ParamT.(name)(i);
                end
            end
            
            result=true;
            return;
        end
    end
 end

