function varargout = CADLIVE_SelectChemG(varargin)
% CADLIVE_SELECTCHEMG M-file for CADLIVE_SelectChemG.fig
%      CADLIVE_SELECTCHEMG, by itself, creates a new CADLIVE_SELECTCHEMG or raises the existing
%      singleton*.
%
%      H = CADLIVE_SELECTCHEMG returns the handle to a new CADLIVE_SELECTCHEMG or the handle to
%      the existing singleton*.
%
%      CADLIVE_SELECTCHEMG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CADLIVE_SELECTCHEMG.M with the given input arguments.
%
%      CADLIVE_SELECTCHEMG('Property','Value',...) creates a new CADLIVE_SELECTCHEMG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CADLIVE_SelectChemG_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CADLIVE_SelectChemG_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CADLIVE_SelectChemG

% Last Modified by GUIDE v2.5 04-Dec-2012 18:33:17

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CADLIVE_SelectChemG_OpeningFcn, ...
                   'gui_OutputFcn',  @CADLIVE_SelectChemG_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CADLIVE_SelectChemG is made visible.
function CADLIVE_SelectChemG_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CADLIVE_SelectChemG (see VARARGIN)

% Choose default command line output for CADLIVE_SelectChemG
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

set(handles.cmbGene,'String', { ...
    CADLIVE_SelectChemO.CMA, ...
    CADLIVE_SelectChemO.TPP_STEADYSTATE_1, ...
    CADLIVE_SelectChemO.TPP_STEADYSTATE_2, ...
    CADLIVE_SelectChemO.TPP_RAPID ...
    });
set(handles.cmbMetabolic,'String', { ...
    CADLIVE_SelectChemO.GMA, ...
    CADLIVE_SelectChemO.MM, ...
    CADLIVE_SelectChemO.SAME_AS_GENE_PROTEIN ...
    });

setappdata(handles.figSelectChem, 'LoadFileName', '');
% UIWAIT makes CADLIVE_SelectChemG wait for user response (see UIRESUME)
% uiwait(handles.cadlive_selectchemg);


% --- Outputs from this function are returned to the command line.
function varargout = CADLIVE_SelectChemG_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in btnFileRef.
function btnFileRef_Callback(hObject, eventdata, handles)
% hObject    handle to btnFileRef (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    % t@CI_CAO\
    [fname, dpath, filterindex] = uigetfile( {'*.xml';'*.txt'}, CADLIVE_Messages.SELECT_CHEM_EQU );
    if filterindex == false 
        return;
    end

    selPapth = fullfile(dpath, fname);
    
    [pathstr,name,ext] = fileparts(selPapth);
	boo = strcmpi(ext,strcat('.','txt'));
    if boo
    	daePath = strcat( pwd, '\', 'MathDAE.txt');
    	usagePath = 'MathUsage.txt';
    	tmpFile = 'tmp';
    	copyfile(selPapth,tmpFile);
    	copyfile(tmpFile,daePath);
    	delete(tmpFile);
    	% _CAOĂяo
    	set( handles.figSelectChem, 'Visible', 'off' );
    	response = CADLIVE_EditUsrFuncG( ...
            CADLIVE_SelectChemO.Name, ...
            CADLIVE_SelectChemO( ...
                selPapth ...
                , '' , '' ...
                , '' , '' ...
                , daePath ...
                , usagePath ...
            ) ...
        );
    	if strcmp( response, 'Quit' )
        	delete(handles.figSelectChem)
        	return;
    	end
    	set( handles.figSelectChem, 'Visible', 'on' );
    	return;
    end
    
    % GfBbg{bNXɐݒ
    set(handles.txtChemicalPath,'String',selPapth);
    
    % w̒os
    executeExtract( selPapth, handles);

% w̒os
function result = executeExtract(fpath, handles)
    if isempty(fpath)
        modalErrorMsgBox(CADLIVE_Messages.INPUT_CHEM_FILE, CADLIVE_Messages.ERROR);
        result = false;
        return;
    end

    % ̃f[^NA
    setappdata(handles.figSelectChem, 'ListGeneProtein', '');
    set( handles.cmbGene, 'Enable', 'off');
    set( handles.lstGeneEqu, 'Enable', 'off');
    set( handles.lstGeneEqu, 'String', '' );
    setappdata(handles.figSelectChem, 'ListMetabolic', '');        
    set( handles.cmbMetabolic, 'Enable', 'off');
    set( handles.lstMetabolic, 'Enable', 'off');
    set( handles.lstMetabolic, 'String', '' );
    
    extractPath = CADLIVE_extract(fpath);
    if( ~isempty(extractPath) )
        [Title, Memo, GeneProtein, Metabolic] = CADLIVE_Tools.readEquation( strcat(pwd, '\', extractPath) );
        setappdata(handles.figSelectChem, 'ListGeneProtein', GeneProtein);
        setappdata(handles.figSelectChem, 'ListMetabolic', Metabolic);        

        % Gene-Proteinw
        lenGene = length(GeneProtein);
        if lenGene > 0 
            set( handles.cmbGene, 'Enable', 'on');
            set( handles.lstGeneEqu, 'Enable', 'on');
            set(handles.lstGeneEqu,'String',GeneProtein);
        else
            set( handles.cmbGene, 'Enable', 'off');
            set( handles.lstGeneEqu, 'Enable', 'off');
        end

        % Metabolicw
        lenMetablic = length(Metabolic);
        if lenMetablic > 0 
            set( handles.cmbMetabolic, 'Enable', 'on');
            set( handles.lstMetabolic, 'Enable', 'on');
            set(handles.lstMetabolic,'String',Metabolic);
        else
            set( handles.cmbMetabolic, 'Enable', 'off');
            set( handles.lstMetabolic, 'Enable', 'off');
        end
    else
        modalErrorMsgBox(CADLIVE_Messages.FAILE_PARSE_CHEM, CADLIVE_Messages.ERROR);
        result = false;
        return;
    end
    
    setappdata(handles.figSelectChem, 'LoadFileName', fpath);
    result = true;

% --- Executes on selection change in cmbGene.
function cmbGene_Callback(hObject, eventdata, handles)
% hObject    handle to cmbGene (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns cmbGene contents as cell array
%        contents{get(hObject,'Value')} returns selected item from cmbGene


% --- Executes during object creation, after setting all properties.
function cmbGene_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cmbGene (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in cmbMetabolic.
function cmbMetabolic_Callback(hObject, eventdata, handles)
% hObject    handle to cmbMetabolic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns cmbMetabolic contents as cell array
%        contents{get(hObject,'Value')} returns selected item from cmbMetabolic


% --- Executes during object creation, after setting all properties.
function cmbMetabolic_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cmbMetabolic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in lstMetabolic.
function lstMetabolic_Callback(hObject, eventdata, handles)
% hObject    handle to lstMetabolic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns lstMetabolic contents as cell array
%        contents{get(hObject,'Value')} returns selected item from lstMetabolic


% --- Executes during object creation, after setting all properties.
function lstMetabolic_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lstMetabolic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in lstGeneEqu.
function lstGeneEqu_Callback(hObject, eventdata, handles)
% hObject    handle to lstGeneEqu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns lstGeneEqu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from lstGeneEqu


% --- Executes during object creation, after setting all properties.
function lstGeneEqu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lstGeneEqu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnQuit.
function btnQuit_Callback(hObject, eventdata, handles)
% hObject    handle to btnQuit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
	delete(handles.figSelectChem)
    
% --- Executes on button press in btnNext.
function btnNext_Callback(hObject, eventdata, handles)
% hObject    handle to btnNext (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    % wf[^t@C
    fpath = getappdata(handles.figSelectChem, 'LoadFileName');
    % fpath = get(handles.editChemicalPath,'String');
    if isempty(fpath)
        modalErrorMsgBox(CADLIVE_Messages.READ_CHEM_FILE, CADLIVE_Messages.ERROR);
        return;
    end
    
    % Gene-ProteinwőIꂽl
    selGenProtein = '';
    GeneProtein = getappdata(handles.figSelectChem, 'ListGeneProtein');
    if ~isempty(GeneProtein)
        val = get(handles.cmbGene,'Value');
        string_list = get(handles.cmbGene,'String');
        selGenProtein = string_list{val}; 
    end
    
    
    % MetabolicwőIꂽl
    selMetabolic = '';
    Metabolic = getappdata(handles.figSelectChem, 'ListMetabolic');
    if ~isempty(Metabolic)
        val = get(handles.cmbMetabolic,'Value');
        string_list = get(handles.cmbMetabolic,'String');
        selMetabolic = string_list{val}; 
    end
    
    if strcmp( selMetabolic, CADLIVE_SelectChemO.SAME_AS_GENE_PROTEIN )
        selMetabolic = selGenProtein;
    end
    
    % parsedaeR}hs
    [daePath, usagePath] = CADLIVE_parsedae( fpath, selGenProtein, selMetabolic );
    if( isempty(daePath) )
        modalErrorMsgBox(CADLIVE_Messages.FAILE_PARSE_CHEM, CADLIVE_Messages.ERROR);
        return;
    end
    daePath = strcat( pwd, '\', daePath);
    
    % _CAOĂяo
    set( handles.figSelectChem, 'Visible', 'off' );
    response = CADLIVE_EditUsrFuncG( ...
            CADLIVE_SelectChemO.Name, ...
            CADLIVE_SelectChemO( ...
                fpath ...
                , selGenProtein , GeneProtein ...
                , selMetabolic , Metabolic ...
                , daePath ...
                , usagePath ...
            ) ...
        );
    if strcmp( response, 'Quit' )
        delete(handles.figSelectChem)
        return;
    end
    set( handles.figSelectChem, 'Visible', 'on' );
    


% --- Executes on button press in btnCadliveTextEditor.
function btnCadliveTextEditor_Callback(hObject, eventdata, handles)
% hObject    handle to btnCadliveTextEditor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    CADLIVE_texteditor();



function editChemicalPath_Callback(hObject, eventdata, handles)
% hObject    handle to editChemicalPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editChemicalPath as text
%        str2double(get(hObject,'String')) returns contents of editChemicalPath as a double


% --- Executes during object creation, after setting all properties.
function editChemicalPath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editChemicalPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%added by inoue 2012/12/04
% --- Executes on button press in btnCadliveNetworkConstructor.
function btnCadliveNetworkConstructor_Callback(hObject, eventdata, handles)
% hObject    handle to btnCadliveNetworkConstructor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    CADLIVE_networkconstructor();