classdef CADLIVE_SetCtrlU < handle
    %CADLIVE_SETCTRLU CADLIVE_SetCtrlG̃[eBeB
    
    methods(Static)
        function toggleSovlerType( rbTag, handles )
            if strcmpi(rbTag, 'rbAdaptiveStepSize' )
                set( handles.editAdaptive, 'Enable', 'on' );
                set( handles.editNDFRelative, 'Enable', 'off' );
                set( handles.editNDFAbsolute, 'Enable', 'off' );
            elseif strcmpi(rbTag, 'rbNDF' )
                set( handles.editAdaptive, 'Enable', 'off' );
                set( handles.editNDFRelative, 'Enable', 'on' );
                set( handles.editNDFAbsolute, 'Enable', 'on' );
            end
        end
        
        function selAnalysis = getAnalysisType(handles)
            val = get(handles.cmbAnalysisType,'Value');
            string_list = get(handles.cmbAnalysisType,'String');
            selAnalysis = string_list{val}; 
        end
        
        function modifyCtrls( handles, selAnalysis, isUseSSystem, isParamSurvey )
           % Rg[̏Ԑݒ
            set( handles.rbAdaptiveStepSize, 'Enable', 'off' );
            set( handles.editAdaptive, 'Enable', 'off' );
            set( handles.rbNDF, 'Enable', 'off' );
            set( handles.editNDFRelative, 'Enable', 'off' );
            set( handles.editNDFAbsolute, 'Enable', 'off' );
            set( handles.editStartTime, 'Enable', 'off' );
            set( handles.editEndtime, 'Enable', 'off' );
            set( handles.editInitialTimeStep, 'Enable', 'off' );
            set( handles.editMornitoring, 'Enable', 'off' );
            set( handles.editMaxTrialTimes, 'Enable', 'off' );
            set( handles.editTolConvFunc, 'Enable', 'off' );
            set( handles.editTolConvVar, 'Enable', 'off' );
            set( handles.editRatioChgParam, 'Enable', 'off' );
            set( handles.editChgCalcSense, 'Enable', 'off' );

            % Use S-system̐ݒ
            %  MathParamS.txt(make_s_param̏o͂炵)Ε\
            if CADLIVE_Tools.isExistFile(CADLIVE_Constant.S_PARAM_FILE) 
                set( handles.chkUseSSsystem, 'Enable', 'on' );
            else
                set( handles.chkUseSSsystem, 'Enable', 'off' );
            end

            selectChemO = getappdata(handles.figsetCTRL, CADLIVE_SelectChemO.Name);
            if strcmpi(selAnalysis, CADLIVE_SetCtrlO.DynamicAnalysis ) && isUseSSystem == 0
                % ԔW̏ꍇ
                set( handles.rbAdaptiveStepSize, 'Enable', 'on' );
                set( handles.rbNDF, 'Enable', 'on' );
                
                % `FbNĂ\oLɂ
                selSolver = get( handles.grpSolverType, 'SelectedObject' );
                CADLIVE_SetCtrlU.toggleSovlerType( get( selSolver, 'Tag' ), handles );
                
                set( handles.editStartTime, 'Enable', 'on' );
                set( handles.editEndtime, 'Enable', 'on' );
                set( handles.editInitialTimeStep, 'Enable', 'on' );
                set( handles.editMornitoring, 'Enable', 'on' );
            end

            if strcmpi(selAnalysis, CADLIVE_SetCtrlO.Steady_StateAnalysis ) ...
                    || ( ...
                        strcmpi(selAnalysis, CADLIVE_SetCtrlO.DynamicAnalysis ) ...
                        && strncmp(selectChemO.GenProtein, CADLIVE_SelectChemO.TPP, length(CADLIVE_SelectChemO.TPP) ) ...
                        )
                % A܂͓w̎ԔW̏ꍇ
                if isUseSSystem == 0
                    set( handles.editMaxTrialTimes, 'Enable', 'on' );
                    set( handles.editTolConvFunc, 'Enable', 'on' );
                    set( handles.editTolConvVar, 'Enable', 'on' );
                    set( handles.editRatioChgParam, 'Enable', 'on' );
                    if strcmpi(selAnalysis, CADLIVE_SetCtrlO.Steady_StateAnalysis ) ...
                            && isParamSurvey == 0
                        set( handles.editChgCalcSense, 'Enable', 'on' );
                    end
                end
            end
        end
        
        function [setCtrl] = getCtrlData(handles)
            setCtrl = CADLIVE_SetCtrlO;
            CADLIVE_CTL = getappdata(handles.figsetCTRL, 'CADLIVE_CTL');
            setCtrl.VarCount = CADLIVE_CTL.N_VAR;
            setCtrl.AlgebrCount = CADLIVE_CTL.N_ALGEBR;
            setCtrl.AnalysisType = CADLIVE_SetCtrlU.getAnalysisType(handles);
            setCtrl.UseSSystem = get( handles.chkUseSSsystem, 'Value' );
            setCtrl.ParamSurvey = get( handles.chkParamSurvey, 'Value' );

            if setCtrl.UseSSystem == 1
                setCtrl.SolverType = CADLIVE_SetCtrlO.SolTypeSSystem;
            else
                selSolver = get( handles.grpSolverType, 'SelectedObject' );
                if strcmpi(setCtrl.AnalysisType, CADLIVE_SetCtrlO.DynamicAnalysis )
                    switch get( selSolver, 'Tag' )
                        case 'rbAdaptiveStepSize'
                            setCtrl.SolverType = CADLIVE_SetCtrlO.SolTypeAdaptive;
                        case 'rbNDF'
                            setCtrl.SolverType = CADLIVE_SetCtrlO.SolTypeNDF;
                    end
                else
                    setCtrl.SolverType = CADLIVE_SetCtrlO.SolTypeSTD;
                end
            end

            setCtrl.RkEPS = str2double(get( handles.editAdaptive, 'String' ));
            setCtrl.NdfRtol = str2double(get( handles.editNDFRelative, 'String' ));
            setCtrl.NdfAtol = str2double(get( handles.editNDFAbsolute, 'String' ));

            setCtrl.StartTime = str2double(get( handles.editStartTime, 'String' ));
            setCtrl.EndTime = str2double(get( handles.editEndtime, 'String' ));
            setCtrl.TimeStep = str2double(get( handles.editInitialTimeStep, 'String' ));
            setCtrl.MonitorInterval = str2double(get( handles.editMornitoring, 'String' ));

            setCtrl.MaxTrialTime = str2double(get( handles.editMaxTrialTimes, 'String' ));
            setCtrl.ToleranceConvFunc = str2double(get( handles.editTolConvFunc, 'String' ));
            setCtrl.ToleranceConvVar = str2double(get( handles.editTolConvVar, 'String' ));
            setCtrl.ParamChgRatio = str2double(get( handles.editRatioChgParam, 'String' ));
            setCtrl.CalcChange = str2double(get( handles.editChgCalcSense, 'String' ));

            setCtrl.GValue = str2double(get( handles.editGValue, 'String' ));
            setCtrl.YDefValue = str2double(get( handles.editYDefVal, 'String' ));
        end
        
        function [res, message] = checkInputData(setCtrl, handles)
            if strcmpi(setCtrl.AnalysisType, CADLIVE_SetCtrlO.DynamicAnalysis )
                if setCtrl.SolverType == CADLIVE_SetCtrlO.SolTypeAdaptive
                    [res, message] = CADLIVE_Tools.isNumeric(setCtrl.RkEPS, CADLIVE_Messages.ERR_RKEPS);
                    if res == false 
                        return;
                    end
                elseif setCtrl.SolverType == CADLIVE_SetCtrlO.SolTypeNDF 
                    [res, message] = CADLIVE_Tools.isNumeric(setCtrl.NdfRtol, CADLIVE_Messages.ERR_NDF_RTOL);
                    if res == false 
                        return;
                    end
                    [res, message] = CADLIVE_Tools.isNumeric(setCtrl.NdfAtol, CADLIVE_Messages.ERR_NDF_ATOL);
                    if res == false 
                        return;
                    end
                end

                [res, message] = CADLIVE_Tools.isNumeric(setCtrl.StartTime, CADLIVE_Messages.ERR_STARTTIME);
                if res == false 
                    return;
                end
                if setCtrl.StartTime < 0 
                    message = CADLIVE_Messages.ERR_STARTTIME;
                    return;
                end
                [res, message] = CADLIVE_Tools.isNumeric(setCtrl.EndTime, CADLIVE_Messages.ERR_ENDTIME);
                if res == false 
                    return;
                end
                if setCtrl.EndTime == 0 
                    message = CADLIVE_Messages.ERR_ENDTIME;
                    return;
                end
                [res, message] = CADLIVE_Tools.isNumeric(setCtrl.TimeStep, CADLIVE_Messages.ERR_STEPTIME);
                if res == false 
                    return;
                end
                if setCtrl.TimeStep == 0 
                    message = CADLIVE_Messages.ERR_STEPTIME;
                    return;
                end
                [res, message] = CADLIVE_Tools.isNumeric(setCtrl.MonitorInterval, CADLIVE_Messages.ERR_MONTIME);
                if res == false 
                    return;
                end
                if setCtrl.MonitorInterval == 0 
                    message = CADLIVE_Messages.ERR_MONTIME;
                    return;
                end

                if setCtrl.MonitorInterval < setCtrl.TimeStep
                    message = CADLIVE_Messages.ERR_MON_STEPTIME;
                    return;
                end
            else
                [res, message] = CADLIVE_Tools.isNumeric(setCtrl.MaxTrialTime, CADLIVE_Messages.ERR_MAX_TRI_TIME);
                if res == false 
                    return;
                end
                [res, message] = CADLIVE_Tools.isNumeric(setCtrl.ToleranceConvFunc, CADLIVE_Messages.ERR_TOL_F);
                if res == false 
                    return;
                end
                [res, message] = CADLIVE_Tools.isNumeric(setCtrl.ToleranceConvVar, CADLIVE_Messages.ERR_TOL_V);
                if res == false 
                    return;
                end
                [res, message] = CADLIVE_Tools.isNumeric(setCtrl.ParamChgRatio, CADLIVE_Messages.ERR_CHG_RATIO);
                if res == false 
                    return;
                end
                tmp = get( handles.editChgCalcSense, 'Enable' );
                if strcmpi( tmp, 'on' )
                    [res, message] = CADLIVE_Tools.isNumeric(setCtrl.CalcChange, CADLIVE_Messages.ERR_CALC_SENSE);
                    if res == false 
                        return;
                    end
                end
            end

            [res, message] = CADLIVE_Tools.isNumeric(setCtrl.GValue, CADLIVE_Messages.ERR_GVALUE);
            if res == false 
                return;
            end
            [res, message] = CADLIVE_Tools.isNumeric(setCtrl.YDefValue, CADLIVE_Messages.ERR_YDEFVALUE);
            if res == false 
                return;
            end

            message = '';
            res = true;
            return;
        end
        
        function updateData(handles, analysisType, isUseSSystem, isParamSurvey)
            clear CADLIVE_initial
            clear CADLIVE_param
            [CADLIVE_CTL Y_START] = CADLIVE_initial();
            [PARAM, EVENT] = CADLIVE_param();
            setappdata(handles.figsetCTRL, 'CADLIVE_CTL', CADLIVE_CTL);
            setappdata(handles.figsetCTRL, 'Y_START', Y_START);
            setappdata(handles.figsetCTRL, 'EVENT', EVENT);
            setappdata(handles.figsetCTRL, 'PARAM', PARAM);

            % Rg[̏Ԑݒ
            CADLIVE_SetCtrlU.modifyCtrls( handles, analysisType, isUseSSystem, isParamSurvey );

            % SolveȓI
            if isUseSSystem == 1
                CADLIVE_CTL.SOLVER = CADLIVE_SetCtrlO.SolTypeSTD;
            else
                if strcmpi(analysisType, CADLIVE_SetCtrlO.DynamicAnalysis )
                    if isnan(CADLIVE_CTL.SOLVER) || CADLIVE_CTL.SOLVER > 10
                        CADLIVE_CTL.SOLVER = CADLIVE_SetCtrlO.SolTypeNDF;
                    end
                elseif strcmpi(analysisType, CADLIVE_SetCtrlO.Steady_StateAnalysis )
                    CADLIVE_CTL.SOLVER = CADLIVE_SetCtrlO.SolTypeSSystem;
                end
            end
            
            switch CADLIVE_CTL.SOLVER
                case CADLIVE_SetCtrlO.SolTypeAdaptive
                    set( handles.grpSolverType, 'SelectedObject', handles.rbAdaptiveStepSize );
                    CADLIVE_SetCtrlU.toggleSovlerType( 'rbAdaptiveStepSize', handles );
                case CADLIVE_SetCtrlO.SolTypeNDF
                    set( handles.grpSolverType, 'SelectedObject', handles.rbNDF );
                    CADLIVE_SetCtrlU.toggleSovlerType( 'rbNDF', handles );
            end

            % ̑f[^̐ݒ
            set( handles.editStartTime, 'String', num2str(CADLIVE_CTL.T_START) );
            set( handles.editAdaptive, 'String', num2str(CADLIVE_CTL.RK_EPS) );
            set( handles.editNDFRelative, 'String', num2str(CADLIVE_CTL.NDF_RTOL) );
            set( handles.editNDFAbsolute, 'String', num2str(CADLIVE_CTL.NDF_ATOL) );
            set( handles.editMaxTrialTimes, 'String', num2str(CADLIVE_CTL.NR_TRIAL) );
            set( handles.editTolConvFunc, 'String', num2str(CADLIVE_CTL.NR_TOL_F) );
            set( handles.editTolConvVar, 'String', num2str(CADLIVE_CTL.NR_TOL_X) );
            set( handles.editRatioChgParam, 'String', num2str(CADLIVE_CTL.NR_RATIO) );
            set( handles.editChgCalcSense, 'String', num2str(CADLIVE_CTL.NR_SENS_CW) );
            set( handles.editGValue, 'String', num2str(CADLIVE_CTL.G_VALUE) );
            set( handles.editYDefVal, 'String', num2str(CADLIVE_CTL.Y_DEFAULT) );
        end
    end
    
    
end

