function varargout = CADLIVE_SetGA(varargin)
%CADLIVE_SETGA M-file for CADLIVE_SetGA.fig
%      CADLIVE_SETGA, by itself, creates a new CADLIVE_SETGA or raises the existing
%      singleton*.
%
%      H = CADLIVE_SETGA returns the handle to a new CADLIVE_SETGA or the handle to
%      the existing singleton*.
%
%      CADLIVE_SETGA('Property','Value',...) creates a new CADLIVE_SETGA using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to CADLIVE_SetGA_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      CADLIVE_SETGA('CALLBACK') and CADLIVE_SETGA('CALLBACK',hObject,...) call the
%      local function named CALLBACK in CADLIVE_SETGA.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CADLIVE_SetGA

% Last Modified by GUIDE v2.5 28-Aug-2012 15:05:51
handles.cpath = pwd;
%Essential Files for optimization  
handles.param = sprintf('%s\\CADLIVE_param.m',handles.cpath);
handles.initial = sprintf('%s\\CADLIVE_initial.m',handles.cpath);
handles.usr_fvec = sprintf('%s\\CADLIVE_usr_fvec.m',handles.cpath);
if exist(handles.param,'file')==false || exist(handles.initial,'file')==false ...
        || exist(handles.usr_fvec,'file')==false
    errordlg('Move to a folder with CADLIVE_param.m, CADLIVE_initial.m and CADLIVE_usr_fvec.m.');
    return;
end

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CADLIVE_SetGA_OpeningFcn, ...
                   'gui_OutputFcn',  @CADLIVE_SetGA_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CADLIVE_SetGA is made visible.
function CADLIVE_SetGA_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for CADLIVE_SetGA
handles.output = hObject;


%default setting
handles.cpath = pwd;
%Essential Files for optimization  
handles.param = sprintf('%s\\CADLIVE_param.m',handles.cpath);
handles.initial = sprintf('%s\\CADLIVE_initial.m',handles.cpath);
handles.usr_fvec = sprintf('%s\\CADLIVE_usr_fvec.m',handles.cpath);


[ctrl, init_y] = CADLIVE_initial();
clear init_y;

if ctrl.SOLVER < 10
    set(handles.txtAnalysisType,'String','Dynamic Analysis');
elseif ctrl.SOLVER == 11
    set(handles.txtAnalysisType,'String','Steady-state Analysis');
elseif ctrl.SOLVER == 12
    set(handles.txtAnalysisType,'String','S-system');
end

handles.maxGeneration = 100;
handles.termination = 1e-20;
handles.numberOfPopulation = 5;
handles.numberOfChildren = 5;
handles.searchType = 'log';
handles.alpha = 0.5;
handles.beta = 0.35;

%Fitness function file
handles.getFitness = sprintf('%s\\CADLIVE_getFitness.m',handles.cpath);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes CADLIVE_SetGA wait for user response (see UIRESUME)
%uiwait(handles.figSetGA);


% --- Outputs from this function are returned to the command line.
function varargout = CADLIVE_SetGA_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function editMaxGeneration_Callback(hObject, eventdata, handles)
% hObject    handle to editMaxGeneration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMaxGeneration as text
%        str2double(get(hObject,'String')) returns contents of editMaxGeneration as a double
handles.maxGeneration=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editMaxGeneration_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMaxGeneration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editTermination_Callback(hObject, eventdata, handles)
% hObject    handle to editTermination (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editTermination as text
%        str2double(get(hObject,'String')) returns contents of editTermination as a double
handles.termination=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editTermination_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editTermination (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editNumberOfPopulation_Callback(hObject, eventdata, handles)
% hObject    handle to editNumberOfPopulation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNumberOfPopulation as text
%        str2double(get(hObject,'String')) returns contents of editNumberOfPopulation as a double
handles.numberOfPopulation=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editNumberOfPopulation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNumberOfPopulation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editNumberOfChildren_Callback(hObject, eventdata, handles)
% hObject    handle to editNumberOfChildren (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNumberOfChildren as text
%        str2double(get(hObject,'String')) returns contents of editNumberOfChildren as a double
handles.numberOfChildren=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editNumberOfChildren_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNumberOfChildren (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popSearchType.
function popSearchType_Callback(hObject, eventdata, handles)
% hObject    handle to popSearchType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% qg: contents = cellstr(get(hObject,'String')) ̓ZzƂ popSearchType ̓eԂ܂B
%        contents{get(hObject,'Value')}  popSearchType IڂԂ܂B
str = get(hObject, 'String');
val = get(hObject,'Value');

% Set current data to the selected data set.
handles.searchType=str{val};
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function popSearchType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popSearchType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editAlpha_Callback(hObject, eventdata, handles)
% hObject    handle to editAlpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editAlpha as text
%        str2double(get(hObject,'String')) returns contents of editAlpha as a double
handles.alpha=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editAlpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editAlpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editBeta_Callback(hObject, eventdata, handles)
% hObject    handle to editBeta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editBeta as text
%        str2double(get(hObject,'String')) returns contents of editBeta as a double
handles.beta=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editBeta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editBeta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btneditParam.
function btneditParam_Callback(hObject, eventdata, handles)
% hObject    handle to btneditParam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

edit(handles.param);



% --- Executes on button press in btnManual.
function btnManual_Callback(hObject, eventdata, handles)
% hObject    handle to btnManual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if exist(handles.getFitness,'file')==0
    fo = fopen(handles.getFitness,'w');
    fprintf(fo,'function fitness = CADLIVE_getFitness(y,t)\n');
    fprintf(fo,'%% t is time.\n'); 
    fprintf(fo,'%% y(col) is steady-state values and t is not used, if analysis type is steady-state analysis.\n');
    fprintf(fo,'%% y(row,col) is dynamics of each dependent variable, if analysis type is dynamic analysis.\n'); 
    fprintf(fo,'%% row is index of value according to t and col is index of dependent variable.\n\n'); 
    fprintf(fo,'fitness = 0;\n\n');
    fprintf(fo,'%%input a fitness function below.\n');
    fclose(fo);
end

edit(handles.getFitness);


% --- Executes on button press in btnUpload.
% squared error for fitness
function btnUpload_Callback(hObject, eventdata, handles)
% hObject    handle to btnUpload (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[Ctrl, init_y] = CADLIVE_initial();

if Ctrl.SOLVER > 10
	% Steady-state analysis
	 errordlg( ...
        'Cannot upload a file in steady-state analysis.' ...
        , 'Upload error' ...
        );
    return;
end

[fname,pn]=uigetfile({'*.txt','text (*.txt)'},'Please select a experimental file');
if ~isempty(fname) && ~isequal(fname,0)
    handles.uploadFile = strcat(pn,fname);
    %Read the upload file and write the CADLIVE_getFitness.m file
	flag=CADLIVE_makeFitnessFile(handles);
    if flag == 1
    	return;
    end
    
    msgbox( ' The fitness file has been successfully made.' );
end

%guidata(hObject,handles);


% --- Executes on button press in btnExecute.
function btnExecute_Callback(hObject, eventdata, handles)
% hObject    handle to btnExecute (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Parameter;
global Events;

%if not edited fitness function
if exist(handles.getFitness,'file')==0
     errordlg( ...
        'Fitness function file not found. Please edit the fitness function.' ...
        , 'Fitness function error' ...
        );
    return;
end



info.maxGeneration = handles.maxGeneration;
info.n_population = handles.numberOfPopulation;
info.n_children = handles.numberOfChildren;
info.allowable_error = handles.termination;
info.searchType = handles.searchType;
info.alpha = handles.alpha;
info.beta = handles.beta;
info.type = 'GA';

info = CADLIVE_writeGAinfo( 0, info, 0);

%GAs
%fprintf('GA_start.\n');
tic;
[fitness info searchParam]= CADLIVE_myGA(info);
time=toc;
%Tp^ݒ̃~X
if fitness == -1
	errordlg( ...
        	'cannot start optimization.' ...
        	, 'Search parameters error' ...
        );
    return;
end

CADLIVE_writeGAinfo( time, info, 1);
fprintf('Output %s.\n',info.optFile);

[ctrl, init_y] = CADLIVE_initial();

%œKlł̃V~[V
try

	SimResult = CADLIVE_simulation();
	if SimResult.Result == false
    	errordlg( ...
        	'cannot optimize.' ...
        	, 'Optimization error' ...
        );
    	return;
	end

	ctrl.SolverType = ctrl.SOLVER;
	ctrl.ParamSurvey = ctrl.P_SURVEY;
	ctrl.SolTypeSTD = 11;
	ctrl.Y_initData = init_y;
	if ctrl.SOLVER < 10
		ctrl.AnalysisType = 'Dynamic Analysis';
	elseif ctrl.SOLVER == 11
		ctrl.AnalysisType = 'Steady-State Analysis';
	elseif ctrl.SOLVER == 12
		ctrl.AnalysisType = 'S-system';
	end
    
    % ʕ\
    if ctrl.SolverType ~= CADLIVE_SetCtrlO.SolTypeSSystem
    	CADLIVE_DispResult( ...
        	CADLIVE_SelectChemO.Name, getappdata(handles.figSetGA, CADLIVE_SelectChemO.Name) ...
            , CADLIVE_EditUsrFuncO.Name, getappdata(handles.figSetGA, CADLIVE_EditUsrFuncO.Name) ...
            , CADLIVE_SetCtrlO.Name, ctrl ...
            , CADLIVE_SetParamO.Name, CADLIVE_SetParamO(SimResult) ...
            , 'Parameter', Parameter ...
        );
    else
        CADLIVE_DispResultS( ...
        	CADLIVE_SelectChemO.Name, getappdata(handles.figSetGA, CADLIVE_SelectChemO.Name) ...
            , CADLIVE_EditUsrFuncO.Name, getappdata(handles.figSetGA, CADLIVE_EditUsrFuncO.Name) ...
            , CADLIVE_SetCtrlO.Name, ctrl ...
            , CADLIVE_SetParamO.Name, CADLIVE_SetParamO(SimResult) ...
        );
    end
catch err
	% O(ɃV~[Ṽp^̑IԈႢ)
    fprintf('%s\n', err.identifier);
    fprintf('%s\n', err.message);
    fprintf('stack trace\n');
    lenStack = length(err.stack);
    for i=1:1:lenStack
    	fprintf( '%04d:%s \n', i, err.stack(i).file );
        fprintf( '     %s(line:%d)\n', err.stack(i).name, err.stack(i).line );
    end
    msgbox( CADLIVE_Messages.FAILE_SIMULATION );
    return;
end

%fitnessl̐
CADLIVE_DispFitnessGraph(fitness);
% Show best fitness
msgbox(sprintf('Best fitness = %e\n',fitness(end)),'Result');



% --- Executes on button press in btnQuit.
function btnQuit_Callback(hObject, eventdata, handles)
% hObject    handle to btnQuit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    delete(handles.figSetGA);
