function varargout = CADLIVE_SetParam(varargin)
% CADLIVE_SETPARAM M-file for CADLIVE_SetParam.fig
%      CADLIVE_SETPARAM, by itself, creates a new CADLIVE_SETPARAM or raises the existing
%      singleton*.
%
%      H = CADLIVE_SETPARAM returns the handle to a new CADLIVE_SETPARAM or the handle to
%      the existing singleton*.
%
%      CADLIVE_SETPARAM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CADLIVE_SETPARAM.M with the given input arguments.
%
%      CADLIVE_SETPARAM('Property','Value',...) creates a new CADLIVE_SETPARAM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CADLIVE_SetParam_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CADLIVE_SetParam_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CADLIVE_SetParam

% Last Modified by GUIDE v2.5 24-Apr-2012 13:14:19

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CADLIVE_SetParam_OpeningFcn, ...
                   'gui_OutputFcn',  @CADLIVE_SetParam_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CADLIVE_SetParam is made visible.
function CADLIVE_SetParam_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CADLIVE_SetParam (see VARARGIN)

% Choose default command line output for CADLIVE_SetParam
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

if(nargin > 3)
    for index = 1:2:(nargin-3),
        switch varargin{index}
        case CADLIVE_SelectChemO.Name
            selectChemO = varargin{index+1};
            setappdata(handles.figSetParam, varargin{index}, selectChemO);
        case CADLIVE_EditUsrFuncO.Name
            editUsrFuncO = varargin{index+1};
            setappdata(handles.figSetParam, varargin{index}, editUsrFuncO);
        case CADLIVE_SetCtrlO.Name
            setCtrl = varargin{index+1};
            setappdata(handles.figSetParam, varargin{index}, setCtrl);
        end
    end
    
    % MathInitVal.txtInitial...{^\B
    % ܂ÂƂ܂ĂȂ̂ŕۗ
    
    paramPath = editUsrFuncO.CheckDaeFiles('param');
    if setCtrl.UseSSystem == 1 
        % make_s_param̏o͂炵
        paramPath = 'MathParamS.txt';
    end
    
    % UIWAIT makes CADLIVE_SetParam wait for user response (see UIRESUME)
    uiwait(handles.figSetParam);
end

% --- Outputs from this function are returned to the command line.
function varargout = CADLIVE_SetParam_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

delete(handles.figSetParam);

% --- Executes on button press in btnRegulatorReactionEqs.
function btnRegulatorReactionEqs_Callback(hObject, eventdata, handles)
% hObject    handle to btnRegulatorReactionEqs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    CADLIVE_DispEquations( ...
        CADLIVE_SelectChemO.Name, getappdata(handles.figSetParam, CADLIVE_SelectChemO.Name) ...
    );


% --- Executes on button press in btnMathModel.
function btnMathModel_Callback(hObject, eventdata, handles)
% hObject    handle to btnMathModel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    selectChemO = getappdata(handles.figSetParam, CADLIVE_SelectChemO.Name);
    edit(selectChemO.DaePath);


% --- Executes on button press in btnUserFuncs.
function btnUserFuncs_Callback(hObject, eventdata, handles)
% hObject    handle to btnUserFuncs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    editUsrFuncO = getappdata(handles.figSetParam, CADLIVE_EditUsrFuncO.Name);
    selUserFunc = get( handles.grpUserFunctions, 'SelectedObject' );
    
    ctrl = getappdata(handles.figSetParam, CADLIVE_SetCtrlO.Name);
    func = '';
    switch get( selUserFunc, 'Tag' )
        case 'rbVec'
            if ctrl.SolverType == CADLIVE_SetCtrlO.SolTypeSSystem
                func = editUsrFuncO.CheckDaeFiles('s_fvec');
            else
                func = editUsrFuncO.CheckDaeFiles('fvec');
            end
        case 'rbJacobian'
            if ctrl.SolverType == CADLIVE_SetCtrlO.SolTypeSSystem
                func = editUsrFuncO.CheckDaeFiles('s_fjac');
            else
                func = editUsrFuncO.CheckDaeFiles('fjac');
            end
    end
    
    if ~isempty(func);
        edit(func);
    end

% --- Executes on button press in btnInitialVal.
function btnInitialVal_Callback(hObject, eventdata, handles)
% hObject    handle to btnInitialVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    editUsrFuncO = getappdata(handles.figSetParam, CADLIVE_EditUsrFuncO.Name);
    selUserFunc = get( handles.grpInitialValue, 'SelectedObject' );
    
    func = '';
    switch get( selUserFunc, 'Tag' )
        case 'rbInitialValue'
            func = editUsrFuncO.CheckDaeFiles('initial');
        case 'rbParameter'
            func = editUsrFuncO.CheckDaeFiles('param');
    end
    
    if ~isempty(func);
        edit(func);
    end


% --- Executes on button press in btnMergeFile.
function btnMergeFile_Callback(hObject, eventdata, handles)
% hObject    handle to btnMergeFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    selMethod = get( handles.grpMergeFile, 'SelectedObject' );
    isUpdAll = false;
    if( strcmpi(get( selMethod, 'Tag' ), 'rbUpdAll' ) )
        isUpdAll = true;
    end
    
    % t@CI_CAO\
    [fname, dpath, filterindex] = uigetfile( '*.txt', CADLIVE_Messages.SELECT_MERGE_FILE );
    if filterindex == false 
        return;
    end
    selPath = fullfile(dpath, fname);

    result = questdlg( ...
        CADLIVE_Messages.CONFIRM_MERGE ...
        , CADLIVE_Messages.CONFIRM ...
        , CADLIVE_Messages.YES ...
        , CADLIVE_Messages.NO ...
        , CADLIVE_Messages.NO ...
        );
    if strcmpi( result, CADLIVE_Messages.NO )
        return;
    end
    
    % p^t@CM-`t@Cɕϊ
    result = CADLIVE_paramToMatlab(selPath);
    if result == false 
        modalErrorMsgBox( ...
            CADLIVE_Messages.FAILE_PARSE_PARAM ...
            , CADLIVE_Messages.ERROR ...
            );
        return;
    end

    % ̒l擾
    setCtrl = getappdata(handles.figSetParam, CADLIVE_SetCtrlO.Name);
    
    try
        %
        % ϊf[^̓ǂݍ
        clear CADLIVE_Merge_init
        M_Y_START = CADLIVE_Merge_init();
        lenY = length(setCtrl.Y_initData);
        for i=1:1:lenY
            if isUpdAll == false
                if isfield(setCtrl.Y_initData(i), 'value')
                    if ~isempty(setCtrl.Y_initData(i).value)
                        continue;
                    end
                end
            end
            idx = CADLIVE_Tools.getIndexY( M_Y_START, setCtrl.Y_initData(i).tag );
            if idx < 0
                continue;
            end

            setCtrl.Y_initData(i).value = M_Y_START(idx).value;
            setCtrl.Y_initData(i).tag = M_Y_START(idx).tag;
        end
        setCtrl.saveInitial('CADLIVE_initial');

        %
        % ϊp^̓ǂݍ
        clear CADLIVE_Merge_param
        [M_PARAM T_EVENT]= CADLIVE_Merge_param();
        
        %add
        if isstruct(T_EVENT) && (setCtrl.SolverType == CADLIVE_SetCtrlO.SolTypeAdaptive || setCtrl.SolverType == CADLIVE_SetCtrlO.SolTypeNDF)
        	temp = 0;
        	lenEvent_ori = length(setCtrl.Event);
        	for i=1:lenEvent_ori
        		temp = temp + 1;
        		event(temp) = setCtrl.Event(i);
        		t(temp) = setCtrl.Event(i).time;
        	end
        	lenEvent = length(T_EVENT);
        	for i=1:lenEvent
        		temp = temp + 1;
        		event(temp) = T_EVENT(i);
        		t(temp) = T_EVENT(i).time;
        	end
        	
        	[t0 ind] = sort(t);
        	
        	for i=1:temp
        		setCtrl.Event(i) = event(ind(i));
        	end
        end


        
        pFields = fields(setCtrl.Parameter);
        lenFields = length(pFields);
        for i=1:1:lenFields
            fieldName = char(pFields(i));
            if ~isfield( setCtrl.Parameter, fieldName )
                continue;
            end
            paramData = setCtrl.Parameter.(fieldName);

            lenP = length( paramData );
            for j=1:1:lenP
                if isUpdAll == false
                    if isfield(paramData(j), 'value')
                        if ~isempty(paramData(j).value)
                            continue;
                        end
                    end
                end

                idx = CADLIVE_Tools.getIndexParam( M_PARAM, fieldName, paramData(j).tag );
                if idx < 0
                    continue;
                end

                setCtrl.Parameter.(fieldName)(j).value = M_PARAM.(fieldName)(idx).value;
                setCtrl.Parameter.(fieldName)(j).num_survey = M_PARAM.(fieldName)(idx).num_survey;
                setCtrl.Parameter.(fieldName)(j).d_r_s = M_PARAM.(fieldName)(idx).d_r_s;
                setCtrl.Parameter.(fieldName)(j).tag = M_PARAM.(fieldName)(idx).tag;
            end
        end
        setCtrl.saveParameter('CADLIVE_param');

        setappdata(handles.figSetParam, CADLIVE_SetCtrlO.Name, setCtrl);
        msgbox( CADLIVE_Messages.CONFIRM_MERGE_END );
    catch err
        fprintf('%s\n', err.identifier);
        fprintf('%s\n', err.message);
        fprintf('stack trace\n');
        lenStack = length(err.stack);
        for i=1:1:lenStack
            fprintf( '%04d:%s \n', i, err.stack(i).file );
            fprintf( '     %s(line:%d)\n', err.stack(i).name, err.stack(i).line );
        end
        
        modalErrorMsgBox( ...
            CADLIVE_Messages.FAILE_PARSE_PARAM ...
            , CADLIVE_Messages.ERROR ...
            );
        return;
    end
    
% --- Executes when user attempts to close figSetParam.
function figSetParam_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figSetParam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure

    handles.output = 'Back';
    
    % Hint: delete(hObject) closes the figure
    if isequal(get(handles.figSetParam, 'waitstatus'), 'waiting')
        % The GUI is still in UIWAIT, us UIRESUME
        uiresume(handles.figSetParam);
    else
        % The GUI is no longer waiting, just close it
        delete(handles.figSetParam);
    end


% --- Executes on button press in btnBack.
function btnBack_Callback(hObject, eventdata, handles)
% hObject    handle to btnBack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    handles.output = 'Back';

    % Update handles structure
    guidata(hObject, handles);

    % Use UIRESUME instead of delete because the OutputFcn needs
    % to get the updated handles structure.
    uiresume(handles.figSetParam);


% --- Executes on button press in btnQuit.
function btnQuit_Callback(hObject, eventdata, handles)
% hObject    handle to btnQuit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    handles.output = 'Quit';

    % Update handles structure
    guidata(hObject, handles);

    % Use UIRESUME instead of delete because the OutputFcn needs
    % to get the updated handles structure.
    uiresume(handles.figSetParam);


% --- Executes on button press in btnExecute.
function btnExecute_Callback(hObject, eventdata, handles)
% hObject    handle to btnExecute (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    result = questdlg( ...
        CADLIVE_Messages.CONFIRM_SIM ...
        , CADLIVE_Messages.CONFIRM ...
        , CADLIVE_Messages.YES ...
        , CADLIVE_Messages.NO ...
        , CADLIVE_Messages.NO ...
        );
    if strcmpi( result, CADLIVE_Messages.NO )
        return;
    end
    %added by inoue, for QMPS
    [Parameter, Events]=CADLIVE_param();
    
    % V~[^s
    try
        [result] = CADLIVE_simulator();
        ctrl = getappdata(handles.figSetParam, CADLIVE_SetCtrlO.Name);
        if result.Result == false && ctrl.ParamSurvey == 0
            exception = MException( ...
                'CADLIVE_simulator:Failed' ...
                , 'Simulation is Failed' ...
                );
           throw(exception);
        end

        % ʕ\
        if ctrl.SolverType ~= CADLIVE_SetCtrlO.SolTypeSSystem
            CADLIVE_DispResult( ...
                CADLIVE_SelectChemO.Name, getappdata(handles.figSetParam, CADLIVE_SelectChemO.Name) ...
                , CADLIVE_EditUsrFuncO.Name, getappdata(handles.figSetParam, CADLIVE_EditUsrFuncO.Name) ...
                , CADLIVE_SetCtrlO.Name, ctrl ...
                , CADLIVE_SetParamO.Name, CADLIVE_SetParamO(result) ...
                , 'Parameter', Parameter ...
            );
        else
            CADLIVE_DispResultS( ...
                CADLIVE_SelectChemO.Name, getappdata(handles.figSetParam, CADLIVE_SelectChemO.Name) ...
                , CADLIVE_EditUsrFuncO.Name, getappdata(handles.figSetParam, CADLIVE_EditUsrFuncO.Name) ...
                , CADLIVE_SetCtrlO.Name, ctrl ...
                , CADLIVE_SetParamO.Name, CADLIVE_SetParamO(result) ...
            );
        end
    catch err
        % O(ɃV~[Ṽp^̑IԈႢ)
        fprintf('%s\n', err.identifier);
        fprintf('%s\n', err.message);
        fprintf('stack trace\n');
        lenStack = length(err.stack);
        for i=1:1:lenStack
            fprintf( '%04d:%s \n', i, err.stack(i).file );
            fprintf( '     %s(line:%d)\n', err.stack(i).name, err.stack(i).line );
        end
        msgbox( CADLIVE_Messages.FAILE_SIMULATION );
    end
