function varargout = CADLIVE_SetQMPS(varargin)
% CADLIVE_SETQMPS MATLAB code for CADLIVE_SetQMPS.fig
%      CADLIVE_SETQMPS, by itself, creates a new CADLIVE_SETQMPS or raises the existing
%      singleton*.
%
%      H = CADLIVE_SETQMPS returns the handle to a new CADLIVE_SETQMPS or the handle to
%      the existing singleton*.
%
%      CADLIVE_SETQMPS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CADLIVE_SETQMPS.M with the given input arguments.
%
%      CADLIVE_SETQMPS('Property','Value',...) creates a new CADLIVE_SETQMPS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CADLIVE_SetQMPS_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CADLIVE_SetQMPS_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CADLIVE_SetQMPS

% Last Modified by GUIDE v2.5 25-Sep-2012 20:24:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CADLIVE_SetQMPS_OpeningFcn, ...
                   'gui_OutputFcn',  @CADLIVE_SetQMPS_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CADLIVE_SetQMPS is made visible.
function CADLIVE_SetQMPS_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CADLIVE_SetQMPS (see VARARGIN)

% Choose default command line output for CADLIVE_SetQMPS
handles.output = hObject;

%recieve result
for index = 1:2:(nargin-3)
    switch varargin{index}
        case CADLIVE_SetParamO.Name
            handles.setParam = varargin{index+1};
        case 'Parameter'
            handles.Parameter = varargin{index+1};
    end
end

%default setting
handles.delta=0.001;
handles.setTargetFile = 'CADLIVE_setTarget.m';

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes CADLIVE_SetQMPS wait for user response (see UIRESUME)
% uiwait(handles.figSetQMPS);


% --- Outputs from this function are returned to the command line.
function varargout = CADLIVE_SetQMPS_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;




% --- Executes on button press in btnTargetFunction.
function btnTargetFunction_Callback(hObject, eventdata, handles)
% hObject    handle to btnTargetFunction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


if exist(handles.setTargetFile,'file')==0
    fo = fopen(handles.setTargetFile,'w');
    fprintf(fo,'function target = CADLIVE_setTarget(y,t)\n');
    fprintf(fo,'%% target is a vector and values of target functions.\n');
    fprintf(fo,'%% t is time.\n');
    fprintf(fo,'%% y(row,col) is dynamics of each dependent variable.\n'); 
    fprintf(fo,'%% row is index of value according to t and col is index of dependent variable.\n\n');  
    fprintf(fo,'%%input a target function for QMPS below.\n');
    fclose(fo);
end
edit(handles.setTargetFile);


function editDelta_Callback(hObject, eventdata, handles)
% hObject    handle to editDelta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editDelta as text
%        str2double(get(hObject,'String')) returns contents of editDelta as a double
handles.delta=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editDelta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editDelta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in btnExecute.
function btnExecute_Callback(hObject, eventdata, handles)
% hObject    handle to btnExecute (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Parameter;
global Events;

    %if not edited target function
    if exist(handles.setTargetFile,'file')==0
        errordlg( ...
            'Target function file not found. Please edit the target function.' ...
            , 'Target function error' ...
        );
        return;
    end
    

    base_time = handles.setParam.SimResult(1).Result_data.time;
    base_y = handles.setParam.SimResult(1).Result_data.y;
    stdy = CADLIVE_setTarget(base_y,base_time);
    clear base_time base_y setParam
    
    [Parameter, Events]=CADLIVE_param();
    Parameter=handles.Parameter;
    %standard parameters
    StandardParameter = Parameter;
    delta = handles.delta;
    
    
    ntar=length(stdy);
    QMPS.value=zeros(ntar,1);
    % QMPS calculation loop
    pFields = fields(Parameter);
    lenFields = length(pFields);
    
    n_param = 0;
    for i=1:lenFields
		name = char(pFields(i));
        if strcmp(name,'constantPlayer')
            continue;
        end
        lenParam = length(Parameter.(name));
        n_param = n_param + lenParam;
    end
    %progress bar
    clear h
	h = waitbar(0,sprintf('1/%d',n_param),'Name','QMPS Progress',...
            'CreateCancelBtn',...
            'setappdata(gcbf,''canceling'',1)');
	setappdata(h,'canceling',0);
	
	a=0;
    for i=1:1:lenFields
        name = char(pFields(i));
        if strcmp(name,'constantPlayer')
            continue;
        end
        lenParam = length(Parameter.(name));
        for j=1:1:lenParam
        	a=a+1;
           	% Check for Cancel button press
    		if getappdata(h,'canceling')
    			delete(h)       % DELETE the waitbar;
        		return;
    		end
    		% Report current estimate in the waitbar's message field
    		waitbar(a/n_param,h,sprintf('%d/%d',a,n_param));
    
            if Parameter.(name)(j).value == 0
                continue;
            end
            Parameter.(name)(j).value=StandardParameter.(name)(j).value*(1+delta);
        
            try
                SimResult = CADLIVE_simulation();
                if SimResult.Result == false
                    delete(h)       % DELETE the waitbar;
                    errordlg( ...
                        'CADLIVE_simulator:Failed 1' ...
                        , 'Simulation is Failed' ...
                    );
                    return;
                end
    
                %ptby: post-changed values of target functions
                % Dynamic analysis
                ptby = CADLIVE_setTarget(SimResult.Result_data.y,SimResult.Result_data.time);
            catch err
                % O(ɃV~[Ṽp^̑IԈႢ)
                fprintf('%s\n', err.identifier);
                fprintf('%s\n', err.message);
                fprintf('stack trace\n');
                lenStack = length(err.stack);
                for i=1:1:lenStack
                    fprintf( '%04d:%s \n', i, err.stack(i).file );
                    fprintf( '     %s(line:%d)\n', err.stack(i).name, err.stack(i).line );
                end
                delete(h)       % DELETE the waitbar;
                msgbox( CADLIVE_Messages.FAILE_SIMULATION );
                return;
            end
            clear SimResult;
        
            %fprintf('%s(%d): p=%f\ts=%f\n',name,j,Parameter.(name)(j).value,StandardParameter.(name)(j).value);
            for k=1:ntar
                QMPS.sensitivity(k,1).value(j,1) = (log(ptby(k))-log(stdy(k)))/(log(Parameter.(name)(j).value)-log(StandardParameter.(name)(j).value));
                QMPS.value(k,1)=QMPS.value(k)+QMPS.sensitivity(k,1).value(j,1)^2;
                %fprintf('ptby=%e\tstdy=%e\tQMPS.value=%f\n',ptby(k),stdy(k),QMPS.value(k));
            end
            QMPS.paramName(j,1) = cellstr(sprintf('%s(%d)',name,j));
        
    		
            %replace standard parameter again
            Parameter.(name)(j).value = StandardParameter.(name)(j).value;
        end
    
    end % QMPS calculation loop
	delete(h)       % DELETE the waitbar;
    msgbox('QMPS: Success','Result');
                
    clear StandardParameter Parameter Events

    %display the result of QMPS
    for i=1:ntar
        handles.QMPS(i) = cellstr(sprintf('%5.4e',QMPS.value(i)));
    end
    set(handles.editResult,'String', handles.QMPS(1));
      
    %Setting popupmenu of Target No.
   nQMPS=length(handles.QMPS);
   for i=1:nQMPS
       str(i)=cellstr(num2str(i));
   end
   set(handles.popTargetNo,'String', str);

guidata(hObject,handles);   
    
    
 
% --- Executes on button press in btnQuit.
function btnQuit_Callback(hObject, eventdata, handles)
% hObject    handle to btnQuit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
delete(handles.figSetQMPS);


% --- Executes on selection change in popTargetNo.
function popTargetNo_Callback(hObject, eventdata, handles)
% hObject    handle to popTargetNo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% qg: contents = cellstr(get(hObject,'String')) ̓ZzƂ popTargetNo ̓eԂ܂B
%        contents{get(hObject,'Value')}  popTargetNo IڂԂ܂B
if isfield(handles, 'QMPS') 
    val = get(hObject,'Value');
    string_list = cellstr(get(hObject,'String'));
    targetNo = floor(str2double(char(string_list{val}))); 
    %display the QMPS selected by user
    set(handles.editResult,'String', handles.QMPS(targetNo));
end

% --- Executes during object creation, after setting all properties.
function popTargetNo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popTargetNo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editResult_Callback(hObject, eventdata, handles)
% hObject    handle to editResult (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editResult as text
%        str2double(get(hObject,'String')) returns contents of editResult as a double


% --- Executes during object creation, after setting all properties.
function editResult_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editResult (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
