function varargout = CADLIVE_SetTPS(varargin)
%CADLIVE_SETTPS M-file for CADLIVE_SetTPS.fig
%      CADLIVE_SETTPS, by itself, creates a new CADLIVE_SETTPS or raises the existing
%      singleton*.
%
%      H = CADLIVE_SETTPS returns the handle to a new CADLIVE_SETTPS or the handle to
%      the existing singleton*.
%
%      CADLIVE_SETTPS('Property','Value',...) creates a new CADLIVE_SETTPS using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to CADLIVE_SetTPS_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      CADLIVE_SETTPS('CALLBACK') and CADLIVE_SETTPS('CALLBACK',hObject,...) call the
%      local function named CALLBACK in CADLIVE_SETTPS.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CADLIVE_SetTPS

% Last Modified by GUIDE v2.5 28-Aug-2012 18:10:26
handles.cpath = pwd;
%Essential Files for optimization  
handles.param = sprintf('%s\\CADLIVE_param.m',handles.cpath);
handles.initial = sprintf('%s\\CADLIVE_initial.m',handles.cpath);
handles.usr_fvec = sprintf('%s\\CADLIVE_usr_fvec.m',handles.cpath);
if exist(handles.param,'file')==false || exist(handles.initial,'file')==false ...
        || exist(handles.usr_fvec,'file')==false
    errordlg('Move to a folder with CADLIVE_param.m, CADLIVE_initial.m and CADLIVE_usr_fvec.m.');
    return;
end

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CADLIVE_SetTPS_OpeningFcn, ...
                   'gui_OutputFcn',  @CADLIVE_SetTPS_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CADLIVE_SetTPS is made visible.
function CADLIVE_SetTPS_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for CADLIVE_SetTPS
handles.output = hObject;


%default setting
handles.cpath = pwd;
%Essential Files for optimization  
handles.param = sprintf('%s\\CADLIVE_param.m',handles.cpath);
handles.initial = sprintf('%s\\CADLIVE_initial.m',handles.cpath);
handles.usr_fvec = sprintf('%s\\CADLIVE_usr_fvec.m',handles.cpath);

[ctrl, init_y] = CADLIVE_initial();
clear init_y;
handles.solver = ctrl.SOLVER;
if ctrl.SOLVER < 10
    set(handles.txtAnalysisType,'String','Dynamic Analysis');
    set(handles.panelEditQMPS,'Visible','on');
elseif ctrl.SOLVER == 11
    set(handles.txtAnalysisType,'String','Steady-state Analysis');
    set(handles.panelEditQMPS,'Visible','off');
elseif ctrl.SOLVER == 12
    set(handles.txtAnalysisType,'String','S-system');
    set(handles.panelEditQMPS,'Visible','off');
end

handles.numberOfSolution = 100;

handles.AE = 1e-5;

handles.maxGeneration = 100;
handles.numberOfPopulation = 5;
handles.numberOfChildren = 5;
handles.searchType = 'log';
handles.alpha = 0.5;
handles.beta = 0.35;

handles.AEC = 1e-3;
handles.RRIG = 0.2;

%Fitness function file
handles.getFitness = sprintf('%s\\CADLIVE_getFitness.m',handles.cpath);

%QMPS
handles.QMPS='on';
handles.delta=0.001;
handles.setTarget = sprintf('%s\\CADLIVE_setTarget.m',handles.cpath);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes CADLIVE_SetTPS wait for user response (see UIRESUME)
%uiwait(handles.figSetTPS);


% --- Outputs from this function are returned to the command line.
function varargout = CADLIVE_SetTPS_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function editNsolution_Callback(hObject, eventdata, handles)
% hObject    handle to editNsolution (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNsolution as text
%        str2double(get(hObject,'String')) returns contents of editNsolution as a double
handles.numberOfSolution=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editNsolution_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNsolution (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editAE_Callback(hObject, eventdata, handles)
% hObject    handle to editAE (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editAE as text
%        str2double(get(hObject,'String')) returns contents of editAE as a double
handles.AE=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editAE_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editAE (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editAEC_Callback(hObject, eventdata, handles)
% hObject    handle to editAEC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editAEC as text
%        str2double(get(hObject,'String')) returns contents of editAEC as a double
handles.AEC=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editAEC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editAEC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editRRIG_Callback(hObject, eventdata, handles)
% hObject    handle to editRRIG (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRRIG as text
%        str2double(get(hObject,'String')) returns contents of editRRIG as a double
handles.RRIG=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editRRIG_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRRIG (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editMaxGeneration_Callback(hObject, eventdata, handles)
% hObject    handle to editMaxGeneration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMaxGeneration as text
%        str2double(get(hObject,'String')) returns contents of editMaxGeneration as a double
handles.maxGeneration=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editMaxGeneration_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMaxGeneration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editNumberOfPopulation_Callback(hObject, eventdata, handles)
% hObject    handle to editNumberOfPopulation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNumberOfPopulation as text
%        str2double(get(hObject,'String')) returns contents of editNumberOfPopulation as a double
handles.numberOfPopulation=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editNumberOfPopulation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNumberOfPopulation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editNumberOfChildren_Callback(hObject, eventdata, handles)
% hObject    handle to editNumberOfChildren (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNumberOfChildren as text
%        str2double(get(hObject,'String')) returns contents of editNumberOfChildren as a double
handles.numberOfChildren=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editNumberOfChildren_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNumberOfChildren (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popSearchType.
function popSearchType_Callback(hObject, eventdata, handles)
% hObject    handle to popSearchType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% qg: contents = cellstr(get(hObject,'String')) ̓ZzƂ popSearchType ̓eԂ܂B
%        contents{get(hObject,'Value')}  popSearchType IڂԂ܂B
str = get(hObject, 'String');
val = get(hObject,'Value');

% Set current data to the selected data set.
handles.searchType=str{val};
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function popSearchType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popSearchType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editAlpha_Callback(hObject, eventdata, handles)
% hObject    handle to editAlpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editAlpha as text
%        str2double(get(hObject,'String')) returns contents of editAlpha as a double
handles.alpha=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editAlpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editAlpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editBeta_Callback(hObject, eventdata, handles)
% hObject    handle to editBeta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editBeta as text
%        str2double(get(hObject,'String')) returns contents of editBeta as a double
handles.beta=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editBeta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editBeta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btneditParam.
function btneditParam_Callback(hObject, eventdata, handles)
% hObject    handle to btneditParam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

edit(handles.param);



% --- Executes on button press in btnManual.
function btnManual_Callback(hObject, eventdata, handles)
% hObject    handle to btnManual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if exist(handles.getFitness,'file')==0
    fo = fopen(handles.getFitness,'w');
    fprintf(fo,'function fitness = CADLIVE_getFitness(y,t)\n');
    fprintf(fo,'%% t is time.\n'); 
    fprintf(fo,'%% y(col) is steady-state values and t is not used, if analysis type is steady-state analysis.\n');
    fprintf(fo,'%% y(row,col) is dynamics of each dependent variable, if analysis type is dynamic analysis.\n'); 
    fprintf(fo,'%% row is index of value according to t and col is index of dependent variable.\n\n'); 
    fprintf(fo,'fitness = 0;\n\n');
    fprintf(fo,'%%input a fitness function below.\n');
    fclose(fo);
end

edit(handles.getFitness);


% --- Executes on button press in btnUpload.
% squared error for fitness
function btnUpload_Callback(hObject, eventdata, handles)
% hObject    handle to btnUpload (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[Ctrl, init_y] = CADLIVE_initial();

if Ctrl.SOLVER > 10
	% Steady-state analysis
	 errordlg( ...
        'Cannot upload a file in steady-state analysis.' ...
        , 'Upload error' ...
        );
    return;
end

[fname,pn]=uigetfile({'*.txt','text (*.txt)'},'Please select a experimental file');
if ~isempty(fname) && ~isequal(fname,0)
    handles.uploadFile = strcat(pn,fname);
    %Read the upload file and write the CADLIVE_getFitness.m file
	flag=CADLIVE_makeFitnessFile(handles);
    if flag == 1
    	return;
    end
    
    msgbox( ' The fitness file has been successfully made.' );
end


%guidata(hObject,handles);



% --- Executes on button press in checkboxQMPS.
function checkboxQMPS_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxQMPS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxQMPS
if (get(hObject,'Value') == get(hObject,'Max'))
    handles.QMPS='on';
else
    handles.QMPS='off';
end
guidata(hObject,handles);


function editDelta_Callback(hObject, eventdata, handles)
% hObject    handle to editDelta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editDelta as text
%        str2double(get(hObject,'String')) returns contents of editDelta as a double
handles.delta=str2double(get(hObject,'String'));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function editDelta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editDelta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnTargetFunction.
function btnTargetFunction_Callback(hObject, eventdata, handles)
% hObject    handle to btnTargetFunction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if exist(handles.setTarget,'file')==0
    fo = fopen(handles.setTarget,'w');
    fprintf(fo,'function target = CADLIVE_setTarget(y,t)\n');
    fprintf(fo,'%% target is a vector and values of target functions.\n');
    fprintf(fo,'%% t is time.\n');
    fprintf(fo,'%% y(row,col) is dynamics of each dependent variable.\n'); 
    fprintf(fo,'%% row is index of value according to t and col is index of dependent variable.\n\n');  
    fprintf(fo,'%%input a target function for QMPS below.\n');
    fclose(fo);
end

edit(handles.setTarget);

% --- Executes on button press in btnExecute.
function btnExecute_Callback(hObject, eventdata, handles)
% hObject    handle to btnExecute (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%if not edited fitness function
if exist(handles.getFitness,'file')==0
     errordlg( ...
        'Fitness function file not found. Please edit the fitness function.' ...
        , 'Fitness function error' ...
        );
    return;
end

%if not edited target function
if exist(handles.setTarget,'file')==0 && handles.solver < 10 && strcmp(handles.QMPS,'on')
     errordlg( ...
        'Target function file not found. Please edit the target function.' ...
        , 'Target function error' ...
        );
    return;
end

info.term_n_solution = handles.numberOfSolution;
info.AE = handles.AE;
info.AEC = handles.AEC;
info.RRIG = handles.RRIG;
info.n_generation = handles.maxGeneration;
info.n_population = handles.numberOfPopulation;
info.n_children = handles.numberOfChildren;
info.searchType = handles.searchType;
info.alpha = handles.alpha;
info.beta = handles.beta;

info.type='TPS';
%TPS̏
info = CADLIVE_writeTPSinfo( 0, info, 0, 0, 0);

%TPSs
%fprintf('TPS_start.\n');
tic;
[solution, searchParam, info, flag] = CADLIVE_myTPS(info);
time=toc;
%fprintf('TPS_finish.\n');

if flag == -1
    return;
end

%write the TPS information
CADLIVE_writeTPSinfo( time, info, solution, searchParam, 1);


%QMPS
if strcmp(handles.QMPS,'on')
    [QMPS, tag]=CADLIVE_TPStoQMPS(handles.delta, info);
    save(info.qmpsFile,'QMPS','tag');
    fprintf('Output %s.\n',info.qmpsFile);
    %ݐϕpxz\
    CADLIVE_DispCumulFreqQMPS(QMPS, tag);
end



% --- Executes on button press in btnQuit.
function btnQuit_Callback(hObject, eventdata, handles)
% hObject    handle to btnQuit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

delete(handles.figSetTPS);
