classdef CADLIVE_Solver < handle
    %CADLIVE_SOLVER ̃NX̊TvɋLq
    %   ڍאɋLq
    
    properties(Constant)
        TINY = 1.0E-30;
    end
    
    properties(Access=protected)
        CONTROL_DATA;
        Param;
        ParamT;
        ParamP;
    end
    
    methods
        function obj = CADLIVE_Solver(ctrl, param, paramT, paramP )
            % RXgN^
            obj.CONTROL_DATA = ctrl;
            obj.Param = param;
            obj.ParamT = paramT;
            obj.ParamP = paramP;
        end
        
        function [result, y] = checkNRresult(obj, y)
            % ANewton-Raphson@ɂẲSĐ̒l
            % Ă邩ۂ𒲂ׂB

            [result, y] = obj.solveNewtonRaphson(y, obj.CONTROL_DATA.N_ALGEBR);
        	if result == false
                return;
            end
            
            %for i=1:1:obj.CONTROL_DATA.N_ALGEBR
            %    if y(i) < 0
            %        result = false;
            %        return;
            %    end
            %end
            
            result = true;
        end
        
        function [result, y, y_pre] = SolveAlgebraicEq(obj, y, y_pre)
            % 2w̎ԔW̏ꍇȂŕύXꂽyA
            % WƂĊ֗^邽߁A܂x@Iɂ̂܂܉Ă݂B
            % WƂĂy̒l̕ω傫ĐɉȂꍇ͑O̒lp
            % QߓIɒl߂ÂďB
            % ۂɂ͔̉傫ωƂ͍lꂸAQߏKvȂ̂
            % ^CCxgƂy̒l傫ύXꂽB
            
            pFields = fields(obj.Param);
            lenParam = length(pFields);
            cnt = 0;
            
            result = obj.checkNRresult(y);
            if result == false
                % @IɉĉȂꍇ
                for i=1+obj.CONTROL_DATA.N_ALGEBR:1:lenParam
                    % ̕ϐỹ[v
                    
                    if y(i) ~= y_pre(i)
                        % OƒlقȂĂꍇ
                        % Qߏɂ
                        cnt = cnt + 1;  % قȂy ̃JEg
                        if y(i) > obj.TINY && y_pre(i) > obj.TINY
                            % lƂɒʏ̂̂̏ꍇ
                            
                            % 䋉Iɒl߂Âꍇ̉
                            [n_iteration, factor] = obj.getIterationTimes(y(i), y_pre(i));
                            
                            % 䋉Iɒl߂ÂĘA
                            for j=1:1:n_iteration
                                y_pre(i) = y_pre(i) * factor;
                                result = obj.checkNRresult(y_pre);
                                if result == false
                                    return;
                                end
                            end
                        else
                            % Vꂩ͗܂͕̏ꍇ
                            
                            % 䋉Iɒl߂Âꍇ̉
                            n_iteration = int32( log(abs( y(i)-y_pre(i) ) ) * 10.0 );
                            if n_iteration <= 1
                                n_iteration = 1;
                            end
                            factor = (y(i) - y_pre(i)) / n_iteration;
                            
                            % 䋉Iɒl߂ÂĘA
                            for j=1:1:n_iteration
                                y_pre(i) = y_pre(i) + factor;
                                result = obj.checkNRresult(y_pre);
                                if result == false
                                    return;
                                end
                            end
                        end
                    end
                end
                if cnt == 0 
                    % ŏɉȂ̂ɕύXׂ y ȂƂƂ
                    % ŏ㐔̕ĂȂƂƂł
                    result = false;
                    return;
                end
                
                % QߏɂlyɃZbg
                y = y_pre;

            end
            
            % ̂߂Ɍ݂̒ly_preɊi[
            y_pre = y;
            result = true;
            return;
        end
        
        function [result, y] = CheckNRparam(obj, y)
            % 2w̎ԔW̏ꍇA^CCxgɂp[^ύXĂȂǂ
            % ׁAύXĂΑQߏsĉB
            % {IɂSetNRparamł邪ԔŴ߂̂̑ȌsB
            
            % SetNRparamp邽߂̑O
            obj.ParamT = obj.Param;
            obj.Param = obj.ParamP;
            
            % Qߏs
            [result, y] = obj.SetNRparam(y);
            if result == false;
                return;
            end
            
            obj.ParamP = obj.Param; % ̂߂Ɍ݂̒lParamPɊi[
            result = true;
            return;
        end
        
        function [result, y] = SetNRparam(obj, y)
            % p[^ύXꂽQߓIɒl߂Âĉ
            
            pFields = fields(obj.ParamT);
            lenParam = length(pFields);
            for i=1:1:lenParam
                name = char(pFields(i));
                
                [result, y] = obj.setOneNRparam( y, name );
                if result == false
                    return;
                end
            end
            
            result = true;
            return;
        end
    end
    methods(Access=protected)
        function [result, y, y_pre] = initSolver(obj, y_start)
            y = y_start;
            if obj.CONTROL_DATA.N_ALGEBR ~= 0
        		[result, y] = obj.SetNRparam(y);
                if result == false
                    return;
                end
            end
            
            obj.ParamP = obj.ParamT;
            obj.Param = obj.ParamT;
            y_pre = y;
            result = true;
        end
        
        function [result, y] = setOneNRparam( obj, y, name )
            % p[^ύXꂽQߓIɒl߂Âĉ(1̃p[^ɂ)
            
            % param.name̔z
            lenParam = length(obj.ParamT.(name));
            for i=1:1:lenParam
        		if obj.ParamT.(name)(i).value ~= obj.Param.(name)(i).value
                    % lĂꍇ
                    [result, y] = obj.changeNRparam( ...
                            obj.ParamT.(name)(i).value ...
                            , name ...
                            , i ...
                            , y ...
                        );
                    if result == false
                        return
                    end
                end
            end
            
            result = true;
        end
        
        function [result, y] = changeNRparam(obj, param, name, idx, y )
            % ύXꂽp[^QߓIɋ߂Âĉ(1̃p[^ɂ)
            
            if param > obj.TINY && obj.Param.(name)(idx).value > obj.TINY
                % lƂʏ̂̂łꍇ
                % 䋉Iɒlωꍇ̉񐔂߂
                [n_iteration, factor] = obj.getIterationTimes(param, obj.Param.(name)(idx).value);
                % l𓙔䋉Iɋ߂ÂĘA
                for i=1:1:n_iteration
        			obj.Param.(name)(idx).value = obj.Param.(name)(idx).value * factor;
        			[result, y] = obj.solveNewtonRaphson(y, obj.CONTROL_DATA.N_ALGEBR);
                    if result == false
                        return;
                    end
                end
            else
                % Vꂩ̒l̏ꍇ
                % Iɒlωꍇ̉񐔂߂
                n_iteration = log( abs(param - obj.Param.(name)(idx).value) )*10.0;
                if n_iteration < 1
                    n_iteration = 1;
                end
                factor = (param - obj.Param.(name)(idx).value) / n_iteration;
                
                % l𓙍Iɋ߂ÂĘA
                for i=1:1:n_iteration
                    obj.Param.(name)(idx).value = obj.Param.(name)(idx).value + factor;
        			[result, y] = obj.solveNewtonRaphson( y, obj.CONTROL_DATA.N_ALGEBR );
                    if result == false 
                        return;
                    end
                end
            end
            
            result = true;
        	return;
        end
        
        function [n_iteration, factor] = getIterationTimes(obj, tg_value, pre_value)
            % 䋉IɑQߏsꍇ̑Q߉񐔂߂B
            
        	ratio = tg_value / pre_value;
        	n_iteration = int32(abs(log(ratio)) / log(obj.CONTROL_DATA.NR_RATIO) + 1);
        	factor = ratio ^ (1.0/double(n_iteration));
        end
        
        function [result, y] = solveNewtonRaphson(obj, y, n)
            % ANewton-Raphson@ɂB
            
        	for k=1:1:obj.CONTROL_DATA.NR_TRIAL
                % JԂvZ̃[v
                fvec = CADLIVE_usr_fvec(y, obj.CONTROL_DATA.G_VALUE, obj.Param);
        		fjac = CADLIVE_usr_fjac(y, obj.CONTROL_DATA.G_VALUE, obj.Param);
                
        		errf=0.0;
                for i=1:1:n
                    errf = errf + abs(fvec(i));
                end
                if errf <= obj.CONTROL_DATA.NR_TOL_F
                    % ֐̎
                    result = true;
                    return;
                end
                
                p = zeros(1,n);
                for i=1:1:n
                    p(i) = -fvec(i);
                end
                [res, fjac, index] = CADLIVE_nr_ludcmp( fjac, n );
                p = CADLIVE_nr_lubksb(fjac, n, index, p);
                
                errx=0.0;
        		for i=1:1:n
        			errx = errx + abs(p(i));
        			y(i) = y(i) + p(i);
                end
                
                if errx <= obj.CONTROL_DATA.NR_TOL_X
                    % ϐ̎?
                    result = true;
        			return;
                end
            end
	
        	% K̉񐔌JԂĂȂꍇ
            result = false;
        	return;
        end
    end
    
end

