function populations = CADLIVE_TPSgetInitialPopulation(population0, searchParam, info)

global Ctrl;

for i=1:info.n_gene
	populations(1).gene(i) = population0.gene(i);
	if strcmp(info.searchType,'real')
    	RIG = info.RRIG * (searchParam(i).upperBound-searchParam(i).lowerBound);
	elseif strcmp(info.searchType,'log')
	    RIG = info.RRIG * (log10(searchParam(i).upperBound)-log10(searchParam(i).lowerBound));
	end

	initialRegion.upperBound(i) = population0.gene(i)+RIG/2;
	initialRegion.lowerBound(i) = population0.gene(i)-RIG/2;
	if initialRegion.lowerBound(i) < searchParam(i).lowerBound
		initialRegion.lowerBound(i) = searchParam(i).lowerBound;
	end
	if initialRegion.upperBound(i) > searchParam(i).upperBound
		initialRegion.upperBound(i) = searchParam(i).upperBound;
	end
end

populations(1).fitness = population0.fitness;
for i = 2:info.n_population
	for j=1:info.n_gene
    	%population(i).gene(j) = rand*(initialRegion.upperBound(j)-initialRegion.lowerBound(j))+initialRegion.lowerBound(j);
    	populations(i).gene(j) = rand;
    	if strcmp(info.searchType,'real')
    		searchParam(j).newValue = populations(i).gene(j) * (initialRegion.upperBound(j)-initialRegion.lowerBound(j))+initialRegion.lowerBound(j);
		elseif strcmp(info.searchType,'log')
	    	searchParam(j).newValue = 10^(populations(i).gene(j)* (initialRegion.upperBound(j)-initialRegion.lowerBound(j))+initialRegion.lowerBound(j));
	    end
	end

	CADLIVE_changeParam(searchParam);
	try
		SimResult = CADLIVE_simulation();
		if SimResult.Result == false
    		populations(i).fitness = 1e+10;
    		continue;
		end
	catch
    	populations(i).fitness = 1e+10;
    	continue;
	end

	if Ctrl.SOLVER < 10
		% Dynamic analysis
		populations(i).fitness = CADLIVE_getFitness(SimResult.Result_data.y,SimResult.Result_data.time);
	else
		% Steady-state analysis
		populations(i).fitness = CADLIVE_getFitness(SimResult.Y,-1);
	end
	clear SimResult
	%fprintf('GAinit(%d):fitness=%e\n',i,population(1).fitness);
end
populations = CADLIVE_sortPopulations(populations);
