classdef CADLIVE_Tools
    %CADLIVE_CONSTANT ̃NX̊TvɋLq
    %   ڍאɋLq
    
    methods(Static)
        function [result] = getXmlText( input )
            result = '';

            if ~isempty(input) 
                result = regexprep(strtrim(char(input.getData)), '\n', '' );
            end
        end
        
        function [Title, Memo, GeneProtein, Metabolic] = readEquation(filename)
            Title = '';
            Memo = '';
            GeneProtein = {};
            Metabolic =  {};

            xDoc = xmlread(filename);

            % title^O擾
            tagTitle = xDoc.getElementsByTagName('title');
            if tagTitle.getLength > 0
                Title = CADLIVE_Tools.getXmlText(tagTitle.item(0).getFirstChild);
            end

            % memo^O擾
            tagMemo = xDoc.getElementsByTagName('memo');
            if tagMemo.getLength > 0
                Memo = CADLIVE_Tools.getXmlText(tagMemo.item(0).getFirstChild);
            end

            % equations^O擾
            tagEquations = xDoc.getElementsByTagName('equations');
            for i=0:tagEquations.getLength-1
                curEqu = tagEquations.item(i);
                layer = char(curEqu.getAttribute('layer'));

                tagEquation = curEqu.getElementsByTagName('equation');
                for j=0:tagEquation.getLength-1
                    equ = CADLIVE_Tools.getXmlText(tagEquation.item(j).getFirstChild);

                    if strcmpi( layer, 'Gene-Protein' ) 
                        GeneProtein{length(GeneProtein)+1} = equ;
                    elseif strcmpi( layer, 'Metabolic' )
                        Metabolic{length(Metabolic)+1} = equ;
                    end
                end
            end
        end
        
        function deleteFile(filename)
            % t@C폜
            if CADLIVE_Tools.isExistFile(filename)
                delete( filename );
            end
        end
        
        function result = isExistFile(filename)
            result = false;
            files = ls(filename);
            if ~isempty(files)
                result = true;
            end
            
            return;
        end
        
        function [result, message] = isNumeric(data, msg)
            
            message = '';
            result = true;
            if isnan(data) || ~isnumeric(data) 
                message = msg;
                result = false;
                return;
            end
        end
        
        function index = getIndexY( y, tag )
            lenY = length(y);
            index = -1;
            for i=1:1:lenY
                if strcmp( y(i).tag, tag )
                    index = i;
                    return;
                end
            end
        end
        
        function index = getIndexParam( param, fieldName, tag )
            index = -1;
            if ~isfield( param, fieldName )
                return;
            end
            
            lenP = length(param.(fieldName));
            for i=1:1:lenP
                if strcmp( param.(fieldName)(i).tag, tag )
                    index = i;
                    return;
                end
            end
        end
     end
end

