function population = CADLIVE_evaluation(population, searchParam, info)
global Ctrl;

searchParam = CADLIVE_decodeGene2Variable(population, searchParam, info);
CADLIVE_changeParam(searchParam);
try
	SimResult = CADLIVE_simulation();
	if SimResult.Result == false
    	population.fitness = 1e+10;
    	return;
	end
catch
    population.fitness = 1e+10;
    return;
end

if Ctrl.SOLVER < 10
	% Dynamic analysis
	population.fitness = CADLIVE_getFitness(SimResult.Result_data.y,SimResult.Result_data.time);
else
	% Steady-state analysis
	population.fitness = CADLIVE_getFitness(SimResult.Y,-1);
end
