function flag=CADLIVE_makeFitnessFile(handles)

flag=0;

fid = fopen(handles.uploadFile,'r');
nline=0;
while 1
	nline=nline+1;
    tline = fgetl(fid);
    if ~ischar(tline), break, end
    t=find(tline=='	');
    ntab = length(t);
    if nline == 1
        fitParamTag = cell(ntab,1);
        fitParamIdx = zeros(ntab,1);
            
        for i=1:ntab-1
            fitParamTag(i) = cellstr(strtrim(tline(t(i)+1:t(i+1)-1)));
        end
        fitParamTag(ntab) = cellstr(strtrim(tline(t(ntab)+1:end)));
    else
        uploadTime(nline-1)=str2double(tline(1:t(1)-1));
        for i=1:ntab-1
            fitParam(i).y(nline-1)=str2double(tline(t(i)+1:t(i+1)-1));
        end
        fitParam(ntab).y(nline-1)=str2double(tline(t(ntab)+1:end));
    end
                  
end
fclose(fid);

numberOfFitParam=length(fitParam);
numberOfExperiment=length(uploadTime);
    
%Edit fitness function
[Ctrl, init_y] = CADLIVE_initial();
n_var = Ctrl.N_VAR;
    
for i=1:numberOfFitParam
    for j=1:n_var
        if strcmp(fitParamTag(i),init_y(j).tag)
            fitParamIdx(i)=j;
            break;
        end
    end
end
    
%tags not found
notFound = find(fitParamIdx==0);
if ~isempty(notFound)
    errordlg( ...
        'Tags in uploaded file are not found. Please check on the command window.' ...
        , 'Tags error' ...
    );
    fprintf('Follow tags in uploaded file are not found.\n');
    for i=1:length(notFound)
        fprintf('%s\n',char(fitParamTag(notFound(i))));
    end
    flag=1;
    return;
end
    
%Overwrite a fitness function file even if the file exists
fo = fopen(handles.getFitness,'w');
fprintf(fo,'%%Squared error\n');
fprintf(fo,'function fitness = CADLIVE_getFitness(y,t)\n\n');
fprintf(fo,'fitness = 0;\n\n');
for i=1:numberOfExperiment
    fprintf(fo,'Texp(%d,1)=%e;',i,uploadTime(i));
    for j=1:numberOfFitParam
        fprintf(fo,'Yexp(%d,%d)=%e;',i,j,fitParam(j).y(i));
    end
    fprintf(fo,'\n');
end
    
fprintf(fo,'\n');
    
for i=1:numberOfFitParam
    fprintf(fo,'%%%s\n',init_y(fitParamIdx(i)).tag);
    fprintf(fo,'yi(:,%d)=interp1(t,y(:,%d),Texp,''spline'');\n',i,fitParamIdx(i));
end
    
fprintf(fo,'\n');
    
fprintf(fo,'numberOfExperiment = %d;\n',numberOfExperiment);
fprintf(fo,'numberOfFitParam = %d;\n',numberOfFitParam);
    
fprintf(fo,'for i=1:numberOfFitParam\n');
fprintf(fo,'\tfor j=1:numberOfExperiment\n');
fprintf(fo,'\t\tif Yexp(j,i) == 0\n');
fprintf(fo,'\t\t\tfitness = fitness + (yi(j,i)-Yexp(j,i))^2;\n');
fprintf(fo,'\t\telse\n');
fprintf(fo,'\t\t\tfitness = fitness + ((yi(j,i)-Yexp(j,i))/Yexp(j,i))^2;\n');
fprintf(fo,'\t\tend\n');
fprintf(fo,'\tend\n');
fprintf(fo,'end\n');
    
fclose(fo);
    