function [fitness, info, searchParam] = CADLIVE_myGA( info)
global Parameter;
global Events;

info.fitness=1e+20;
info.n_generation=0;
info.progressStop = false;

%Call initial parameters
[Parameter, Events] = CADLIVE_param();

%searchParam: basic information for search parameters
[searchParam, flag]=CADLIVE_setSearchParamter(info.searchType);
info.n_gene=length(searchParam);

%search paramters are not set correctly
if flag == -1
	fitness = -1;
	return;
end

%Initial setting for progress bar
info.h = waitbar(0,sprintf('0/%d',info.maxGeneration),'Name','GA Progress',...
            'CreateCancelBtn',...
            'setappdata(gcbf,''canceling'',1)');
setappdata(info.h, 'canceling', 0);
info = CADLIVE_showProgressBar(info);

%population: calculation information for search parameters
populations = CADLIVE_getInitialPopulations(searchParam, info);
population1 = populations(1);
fprintf('%d: Best Fitness = %e\n',1,populations(1).fitness);
info.fitness = populations(1).fitness;
info.n_generation=1;
info = CADLIVE_showProgressBar(info);

fitness(1) = populations(1).fitness;
if populations(1).fitness <= info.allowable_error
    searchParam = CADLIVE_decodeGene2Variable(populations(1), searchParam, info);
    CADLIVE_changeParam(searchParam);% Change global variable Parameter
    delete(info.h)
    return;
end

for i = 2:info.maxGeneration
    
    [populations, info] = CADLIVE_MGGvariant(populations, searchParam, info);
    fprintf('%d: Best Fitness = %e\n', i, populations(1).fitness);
	
	if info.progressStop
		searchParam = CADLIVE_decodeGene2Variable(population1, searchParam, info);
	else
		searchParam = CADLIVE_decodeGene2Variable(populations(1), searchParam, info);
	end
	CADLIVE_changeParam(searchParam);
    
    if info.progressStop
        delete(info.h)  % DELETE the waitbar;
        return;
    end
    
    info.fitness = populations(1).fitness;
    CADLIVE_saveGAResult(populations(1), searchParam, info);
    info.n_generation = i;
    info = CADLIVE_showProgressBar(info);
    population1=populations(1);
    fitness(i)= populations(1).fitness;
    if populations(1).fitness <= info.allowable_error
        delete(info.h)       % DELETE the waitbar;
        return;
    end
    
end

searchParam = CADLIVE_decodeGene2Variable(populations(1), searchParam, info);
CADLIVE_changeParam(searchParam);
delete(info.h)       % DELETE the waitbar;
