function [SimResult fitness] = CADLIVE_myGAcommand(...
    maxGeneration, n_population, n_children, termination, searchType, alpha, beta)
%Don't display the result as GUI

global Parameter;
global Events;

info.maxGeneration = maxGeneration;
info.n_population = n_population;
info.n_children = n_children;
info.allowable_error = termination;
info.searchType = searchType;
info.alpha = alpha;
info.beta = beta;
info.type = 'GA';

info = CADLIVE_writeGAinfo( 0, info, 0);

%GAs
%fprintf('GA_start.\n');
tic;
[fitness info searchParam]= CADLIVE_myGA(info);
time=toc;

%Tp^ݒ̃~X
if fitness == -1
	errordlg( ...
        	'cannot start optimization.' ...
        	, 'Search parameters error' ...
        );
end

CADLIVE_writeGAinfo( time, info, 1);


%Simulation with optimized parameters
try
	SimResult = CADLIVE_simulation();
	if SimResult.Result == false
    	errordlg( ...
        	'cannot optimize.' ...
        	, 'Optimization error' ...
        );
    	return;
	end

catch err
    fprintf('%s\n', err.identifier);
    fprintf('%s\n', err.message);
    fprintf('stack trace\n');
    lenStack = length(err.stack);
    for i=1:1:lenStack
    	fprintf( '%04d:%s \n', i, err.stack(i).file );
        fprintf( '     %s(line:%d)\n', err.stack(i).name, err.stack(i).line );
    end
    msgbox( CADLIVE_Messages.FAILE_SIMULATION );
    return;
end


