function [C F] = CADLIVE_mycumulhist(X,n,lb,ub)
% [C F] = CADLIVE_mycumulhist(X,n,lb,ub)
%
% mycumulhist function makes cumulative histograms from X.
% To plot the output, use "plot(C,F./length(X),'-o');".
%
% X:  Data matrix whose each column shows each data set.
% n:  The number of classes.
% lb: Lower bound of the cumulative histograms. 
% ub: Upper bound of the cumulative histograms. 
% C:  Class value vector.
% F:  Cumulative Frequency matrix whose column shows one data set.

[C Temp]= CADLIVE_myhist(X,n,lb,ub);

[n_row n_col]=size(Temp);
F=zeros(n_row,n_col);
F(1,:)=Temp(1,:);
for i=2:n_row
    F(i,:)=F(i-1,:)+Temp(i,:);
end
