classdef CADLIVE_ode < CADLIVE_Solver
    %CADLIVE_ode ̃NX̊TvɋLq
    %   ڍאɋLq
    
    methods
        function obj = CADLIVE_ode(ctrl, param, paramT, paramP)
            % RXgN^
            obj = obj@CADLIVE_Solver(ctrl, param, paramT, paramP);
        end
        
        function [result, res_time, res_y, y, y_pre] = doSolver(obj, y_start, Events)
            lenY = length(y_start);
            
            res_time = [];
            res_y = [];
        
            % \o[̑O
            [result, y, y_pre] = obj.initSolver(y_start);
            if result == false
                return;
            end
            
            % Cxg̎𒲂ׂB
            evts_ = obj.get_simultaneous_events( ...
                obj.CONTROL_DATA.T_START ...
                , obj.CONTROL_DATA.T_END ...
                , Events ...
                ); 

            % Y_ADD ̂Ԃ𒲂ׂB
            is_yadding = obj.get_adding_periods(evts_);

            % CxgƎ̃Cxg̊ԂƂɁA
            % ̏o͎ݒ肷B
            [lenEvents, evnt_t, event_t_len] = obj.getEventInterval(evts_);
            
            % IvV̐ݒ
            %  ndf_init()̓e
            options = obj.ndf_init();

             % CxgƎ̃Cxg̊ԂƂɁAsolversB
%            idxIt = 1;
            y_add = zeros(lenY);
            for ie=1:1:lenEvents
                % Cxgs
                [hasParamEvents, y, y_add] = obj.do_events(evts_(ie).Events, y, y_add);

                % A
                [result, y, y_pre] = obj.executeSolveAlgebraicEq( y, y_pre, hasParamEvents );

                % Y_ADD ꍇAo͊ԊuŃ\o[sB
                %         ȂꍇACxgԊuŃ\o[sB
                if is_yadding(ie) == true
                    lenTimeStep = length(event_t_len(ie));
                else
                    lenTimeStep = 2;
                    time_step_exec = zeros(1, event_t_len(ie));
                    for i=1:1:event_t_len(ie)
                        time_step_exec(1,i) = evnt_t(ie,i);
                    end
                end
                for its=1:1:(lenTimeStep-1)
                    if is_yadding(ie) == true
                        % Y_ADD ꍇAo͊Ԋuݒ
                        time_step_exec(1) = evnt_t(its);
                        time_step_exec(2) = evnt_t(its+1);
                    end
                    
                    % \os
                    [t_time, t_y]=obj.executeSolver(time_step_exec, y, options);

                    % o
                    [y, t_y, res_time, res_y, y_pre] = obj.outputResponse( ...
                        y ...
                        , t_time ...
                        , t_y ...
                        , is_yadding(ie) ...
                        , y_add ...
                        , res_time ...
                        , res_y ...
                        );
                end
            end
            
            result = true;
        end
    end
        
    methods(Access=protected)
        function evts = get_simultaneous_events( obj, t_st, t_ed, Events )
            % CxgƂɕA
            % ɔCxgEvent\̂̐擪AhX擾B
            %	t_st                                          t_ed
            %	+-------------+-------------+-----------------+
            %	e0           e1,e2         e3,e4,e5           e6
            %	evts[0] = e0 evts[1] = e1  evts[2] = e3       evts[3] = e6
            
            prev_time = t_st;
            idxEvent = 1;
            evts(1).Events(idxEvent) = Events(1);
            nevts = 2;
            
            % CxǵAɕłOB
            % time_start Cxgn܂āAtime_end CxgŏIB
            lenEvents = length(Events);
            for i=1:1:lenEvents
                if Events(i).time <= prev_time
                    idxEvent = idxEvent + 1;
                    evts(nevts-1).Events(idxEvent) = Events(i);
                    continue;
                end
                idxEvent = 1;
                
                if Events(i).time > t_ed
                    break;
                end
                prev_time = Events(i).time;
                evts(nevts).Events(idxEvent) = Events(i);
                nevts = nevts + 1;
            end
        end
        
        function is_yadding = get_adding_periods( obj, evts )
            % CxgƃCxg̊ԂɁAY_ADD 邩ׂB
            
            lenEvents = length(evts);
            is_yadding = false( 1, lenEvents );
            
            adding = zeros(1, lenEvents);
            for ie=1:1:(lenEvents-1)
                % Cxg[v
                lenSTEvent = length(evts(ie).Events);
                for i=1:1:lenSTEvent
                    if ~strcmp( evts(ie).Events(i).name, CADLIVE_Constant.Y_ADD ) 
                        continue;
                    end
                    if evts(ie).Events(i).value == 0 
                        adding(ie) = adding(ie) - 1;
                    end
                        adding(ie) = adding(ie) + 1;
                end
                if adding(ie) > 0
                    is_yadding(ie) = true;
                end
            end
        end
        
        function [hasParamEvents, y, y_add] = do_events(obj, Events, y, y_add)
            % Cxg̓esB
            
            lenEvents = length(Events);
            hasParamEvents = false;
            for ie=1:1:lenEvents
                if strcmp( Events(ie).name, CADLIVE_Constant.Y_FORCE )
                    y( Events(ie).index ).value = Events(ie).value;
                elseif strcmp( Events(ie).name, CADLIVE_Constant.Y_ADD )
                    y_add( Events(ie).index ).value = Events(ie).value;
                elseif strcmp( Events(ie).name, CADLIVE_Constant.TIME_START )
                    % do nothing
                elseif strcmp( Events(ie).name, CADLIVE_Constant.TIME_END )
                    % do nothing
                else
                    obj.Param.( Events(ie).name )(Events(ie).index).value = Events(ie).value;
                    hasParamEvents = true;
                end
            end
        end
    end
    
    methods(Access=protected, Abstract=true)
        [t_time, t_y] = executeSolver(obj, time_step_exec, y, options)
        [result, y, y_pre] = executeSolveAlgebraicEq(obj, y, y_pre, hasParamEvents)
        [options] = ndf_init(obj)
        [lenEvents, evn_t, event_t_len] = getEventInterval(obj, evts_)
        [y, t_y, res_time, res_y, y_pre] = outputResponse(obj, y, t_time, t_y, is_yadding, y_add, res_time, res_y)
    end
end

