classdef CADLIVE_ode45 < CADLIVE_ode
    %CADLIVE_ODE45S ̃NX̊TvɋLq
    %   ڍאɋLq
    properties(Access=private)
        nEventCount;
    end
    
    methods
        function obj = CADLIVE_ode45(ctrl, param, paramT, paramP)
            % RXgN^
            obj = obj@CADLIVE_ode(ctrl, param, paramT, paramP);
            obj.nEventCount = 0;
        end
    end
    
    methods(Access=protected)
        function [options] = ndf_init(obj)
            options = odeset( ...
                'RelTol', obj.CONTROL_DATA.RK_EPS ...   % ftHg
                , 'NormControl', 'off' ...              % ftHg
                , 'MStateDependence', 'weak' ...        % ftHg
                , 'MassSingular', 'maybe' ...
                , 'MaxOrder', 5 ...                     % ftHg
                , 'BDF', 'off' ...                      % ftHg
                , 'InitialStep', obj.CONTROL_DATA.DELTA_T ... 
                , 'MaxStep', obj.CONTROL_DATA.DELTA_M ...
                );
        end
        
        function [lenEvents, evnt_t, event_t_len] = getEventInterval(obj, evts_)
            lenEvents = length(evts_)-1;
            evnt_t = zeros(lenEvents, 2);
            for ie=1:1:lenEvents
                % o͎ݒ
                % (KȂ̂ŁAł͏ڍׂȏo͎Ԃw肹ode45ɔC)
                evnt_t(ie, 1) = evts_(ie).Events(1).time;
                evnt_t(ie, 2) = evts_(ie + 1).Events(1).time;
                event_t_len = 2;
            end
        end

        function [t_time, t_y] = executeSolver(obj, time_step_exec, y, options)
            global Parameter;
            
            param_bk = Parameter;
            Parameter = obj.Param;
            [t_time, t_y]=ode45(@CADLIVE_odefunc,time_step_exec, y, options);
            Parameter = param_bk;
        end
        
        function [result, y, y_pre] = executeSolveAlgebraicEq(obj, y, y_pre, hasParamEvents)
            result = true;
        end
        
        function [y, t_y, res_time, res_y, y_pre] = outputResponse(obj, y, t_time, t_y, is_yadding, y_add, res_time, res_y)
            lenY = length(y);
            lenT = length(t_time);

            % 擪̃f[^ݒ
            % corrected by inoue
            %idxIt = length(res_time)+1;
            if length(res_time) == 0
               idxIt = 1;
            else
               idxIt = length(res_time);
            end
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            pre_time = t_time(1);
            [res_time, res_y] = obj.putResult( lenY, 1, t_time, t_y, idxIt, res_time, res_y);
            idxIt = idxIt + 1;
            
            for it=2:1:lenT-1
                % o͎Ԃ𔻒
                % Oo͎ԂƂ̍ > obj.CONTROL_DATA.DELTA_M̏ꍇ
                if (t_time(it) - pre_time) > obj.CONTROL_DATA.DELTA_M
                    pre_time = t_time(it);
                    [res_time, res_y] = obj.putResult( lenY, it, t_time, t_y, idxIt, res_time, res_y);
                    idxIt = idxIt + 1;
                end
            end
            
            % Ō̃f[^ݒ
            [res_time, res_y] = obj.putResult( lenY, lenT, t_time, t_y, idxIt, res_time, res_y);

            for i=1:1:lenY
                y(i) = res_y(idxIt,i);
            end
            
            % Y_ADD̏
            for i=1+obj.CONTROL_DATA.N_ALGEBR:1:obj.CONTROL_DATA.N_VAR
                y(i) = y(i) + y_add(i);
            end
            y_pre = y;
        end
        
        function [res_time, res_y] = putResult(obj, lenY, srcIdx, t_time, t_y, dstIdx, res_time, res_y)
            % ʂo
            res_time(dstIdx,1) = t_time(srcIdx);
            for i=1:1:lenY
                res_y(dstIdx, i) = t_y(srcIdx, i) / obj.CONTROL_DATA.G_VALUE;
            end
        end
        
    end
end

