function fitness = CADLIVE_optimtoolGUIfunc(x)

global Parameter;
global Events;


[Ctrl, init_y] = CADLIVE_initial();
[Parameter, Events] = CADLIVE_param();
%load only search parameters, not relate to bounds in this parameters
[searchParam flag]=CADLIVE_setSearchParamter('log');
%search paramters are not set
if flag == -1
	error('Search parameters are not set.');
end

for i=1:length(searchParam)
    searchParam(i).newValue = x(i);
end
CADLIVE_changeParam(searchParam);

try
	SimResult = CADLIVE_simulation();
	if SimResult.Result == false
    	fitness = 1e+10;
    	return;
	end
catch
    fitness = 1e+10;
    return;
end

if Ctrl.SOLVER < 10
	% Dynamic analysis
	fitness = CADLIVE_getFitness(SimResult.Result_data.y,SimResult.Result_data.time);
else
	% Steady-state analysis
	fitness = CADLIVE_getFitness(SimResult.Y,-1);
end

