%For command line in Optimization toolbox
function fitness = CADLIVE_optimtoolfunc(x)

global Ctrl;
global Parameter;
global Events;
global searchType;
global searchParam;

for i=1:length(searchParam)
    individual.gene(i) = x(i);
end
searchParam = CADLIVE_decodeGene2Variable(individual,length(searchParam),searchParam, searchType);
CADLIVE_changeParam(searchParam);

try
	SimResult = CADLIVE_simulation();
	if SimResult.Result == false
    	fitness = 1e+10;
    	return;
	end
catch
    fitness = 1e+10;
    return;
end

if Ctrl.SOLVER < 10
	% Dynamic analysis
	fitness = CADLIVE_getFitness(SimResult.Result_data.y,SimResult.Result_data.time);
else
	% Steady-state analysis
	fitness = CADLIVE_getFitness(SimResult.Y,-1);
end

