function [SimResult] = CADLIVE_simulatorForIteration(CADLIVE_CTL, Y_START, param, event)
global GeneConc;
global Ctrl;
global Parameter;
global Events;

	Ctrl = CADLIVE_CTL;
	init_y = Y_START;
	Parameter = param;
	Events = event;
	
    %clear CADLIVE_initial
    %clear CADLIVE_param
    clear CADLIVE_get_GHdata
    clear CADLIVE_get_GHnum
    clear CADLIVE_S_usr_fvec
    clear CADLIVE_S_usr_fjac
    clear CADLIVE_usr_fvec
    clear CADLIVE_usr_fjac
    clear CADLIVE_usr_flux


    %[Ctrl, init_y] = CADLIVE_initial();
    GeneConc=Ctrl.G_VALUE;
   
    % lsɕύX
    y = convY(Ctrl, init_y);
    Ctrl.N_VAR = length(y);
    y_start = y;
    y_pre = y;
	for i=1:Ctrl.N_VAR
		tag(i) = cellstr(init_y(i).tag);
	end
    % p^̐ݒ
    %[ParameterT, Events] = CADLIVE_param();
    ParameterT = Parameter;
    ParameterT = convParam(ParameterT);
    ParameterT = initParam(Ctrl, ParameterT);

    % p^T[xC̐ݒ
    [result, Survey] = setParamSurvey( Ctrl, ParameterT );
    if result == false
        return;
    end
    


    if Ctrl.SOLVER > 10
        Ctrl.N_ALGEBR = Ctrl.N_VAR;
    end
    Parameter = ParameterT;
    
    % ParameterɃX^[glݒ肷
    Parameter = setStartValue(Parameter);
    ParameterP = Parameter;
    ParameterS = Parameter;
    ParameterB = ParameterT;

    % p[^T[xCsꍇ̃T[xČvZ
    [start_survey, end_survey] = calcTotalSurvey(Ctrl, Survey);
    
    % p[^T[xC̃[v
    doSolver = CADLIVE_DoSolver(Ctrl, Parameter, ParameterT, ParameterP, Events, init_y);
    for i_survey=start_survey:1:end_survey
        if Ctrl.P_SURVEY == 1
            % ̉̃p[^Zbg
            [ ParameterB, ParameterT ] = setSurveyValue( Ctrl, ParameterB, ParameterT, Survey, i_survey );
            doSolver.ParamT = ParameterT;
        end

        if Ctrl.SOLVER < 10
            Parameter = ParameterS;
        end

        % \os
        [ result, res_data, y, y_pre ] = doSolver.DoSolver( y_start, y, y_pre );
        
        % ɕfalse - added by inoue 2012/09/25
        if Ctrl.SOLVER == 11 || Ctrl.SOLVER == 12
        	if min(y) < 0
        		result = false;
        		%fprintf('Negative value...\n');
        	end
        else
        	if min(min(res_data.y)) < 0
        		result = false;
        		%fprintf('Negative value...\n');
        	end
        	if res_data.time(end) ~= Ctrl.T_END
        		result = false;
        	end
        end
        
        % ʐݒ
        SimResult(i_survey).Result = result;
        if result == true
            SimResult(i_survey).Result_data = res_data;
            SimResult(i_survey).Y = y;
            SimResult(i_survey).Y_pre = y_pre;
			SimResult(i_survey).tag = tag;
			
            % 񑊕łȂꍇ͌ŗLlvZďo
            if Ctrl.P_SURVEY == 0 && (Ctrl.N_ALGEBR == 0 || Ctrl.N_ALGEBR == Ctrl.N_VAR)
                if Ctrl.SOLVER == 12
                    fjac = CADLIVE_S_usr_fjac(y, Ctrl.G_VALUE, Parameter);
                else
                    fjac = CADLIVE_usr_fjac(y, Ctrl.G_VALUE, Parameter);
                end
                [ SimResult(i_survey).Eigen ] = eig(fjac);
            end
        else
            if Ctrl.P_SURVEY == 0
                % G[I
                return;
            else
                doSolver.Param = ParameterS;
                continue;
            end
        end
    end
    
    %{
    % GHn֐̑݃`FbN
    isGH = ~isempty(ls('CADLIVE_get_GHnum.m'));
    if Ctrl.SOLVER ~= 12 && Ctrl.P_SURVEY == 0 && isGH == true
        % make_s_param̎s
        [res_y_init, res_param] = CADLIVE_make_s_param(Ctrl, init_y,  SimResult(1).Y,  ParameterT);
        outdata.res_y_init = res_y_init;
        outdata.res_param = res_param;
        save(CADLIVE_Constant.S_PARAM_FILE, '-struct', 'outdata');
        SimResult(1).S_Param.y_init = res_y_init;
        SimResult(1).S_Param.param = res_param;
    end
    %}
end

function y = convY(Ctrl, init_y)
% convY lsɕύX

    y_start_len = length(init_y);
    y = zeros(y_start_len,1);
    for i=1:1:y_start_len
        if ~isfield(init_y(i), 'value' ) || isempty(init_y(i).value)
            y(i) = Ctrl.Y_DEFAULT * Ctrl.G_VALUE;
        else
            y(i) = init_y(i).value * Ctrl.G_VALUE;
        end
    end
end

function param = convParam(param)
    % convParam valueݒ̕ϐ0ݒ肷B
    % atofŕϊoȂƂ0ɂȂ̂
    
    % Sp^ɑ΂čs
    pFields = fields(param);
    lenFields = length(pFields);
    for i=1:1:lenFields
        fieldName = char(pFields(i));
        
        % p^̓eɑ΂čs
        lenP = length(param.(fieldName));
        for j=1:1:lenP
            if ~isfield( param.(fieldName)(j), 'value' )
                param.(fieldName)(j).value = 0;
            end
        end
    end
end

function param = initParam(Ctrl, param)
% initParam ϐ̏ݒ
     if ~isfield( param, 'constantPlayer')
          return;
     end

    lenConst = length(param.constantPlayer);
    for i=1:1:lenConst
        if ~isfield(param.constantPlayer(i), 'value')
            param.constantPlayer(i).value = 0;
        end
         param.constantPlayer(i).value = param.constantPlayer(i).value * Ctrl.G_VALUE;
    end
end

function [result, Survey] = setParamSurvey(Ctrl, Param)
% setParamSurvey p^T[xC̐ݒ

    idxSurvey = 1;
    Survey = zeros(0,0);
    
    % Sp^ɑ΂čs
    pFields = fields(Param);
    lenFields = length(pFields);
    for i=1:1:lenFields
        name = char(pFields(i));

        lenParam = length(Param.(name));
        for j=1:1:lenParam
            steps = int32(Param.(name)(j).num_survey);
            if steps == 0
                continue;
            end
            if steps < 2
                result = false;
                return;
            end

            % p[^̐Ũ^Cv̐ݒ
            if strcmp( Param.(name)(j).d_r_s, 'D' )
                isArithmeticis = true;
            elseif strcmp( Param.(name)(j).d_r_s, 'R' )
                isArithmeticis = false;
            else
                result = false;
                return;
            end

            % ύXl̗L̃`FbN
            if isfield( Param.(name)(j), 'change_val' ) == false
                result = false;
                return;
            end
            change_val = int32(Param.(name)(j).change_val);

            if isArithmeticis == true ...
                    && strcmp( name, CADLIVE_Constant.CONST_PLAYER )
                change_val = change_val * Ctrl.G_VALUE;
            end

            % l̐̃`FbN
            if isArithmeticis == true && change_val == 0.0
                result = false;
                return;
            end
            if isArithmeticis == false ...
                    && (change_val == 1.0 || change_value <= 0.0 || value == 0.0)
                result = false;
                return;
            end

            % T[xCli[
            Survey(idxSurvey).name = name;
            Survey(idxSurvey).index = j;
            Survey(idxSurvey).steps = steps;
            Survey(idxSurvey).isArithmeticis = isArithmeticis;
            Survey(idxSurvey).start_value = Param.(name)(j).value;
            Survey(idxSurvey).change_value = change_val;
            idxSurvey = idxSurvey + 1;
        end
    end
    
    result = true;
end

function [ Parameter ] = setStartValue( Parameter )
%setStartValue eϐstart_valueݒ肷

    pVars = fieldnames(Parameter);
    lenVars = length(pVars);
    for i=1:1:lenVars
        varName = char(pVars(i));

        % \̔z擾(ϐ̒lꗗ)
        var = Parameter.(varName);
        lenValues = length(var);
        for j=1:1:lenValues
            % val_startoɒl΃ZbgB
            if isfield(var(j), 'val_start') 
                if ~isempty(var(j).val_start)
                    Parameter.(varName)(i).value =  var(j).val_start;
                end
            end
        end
    end

end

function [start_survey, end_survey] = calcTotalSurvey(Ctrl, Survey)
% calcTotalSurvey p[^T[xCsꍇ̃T[xČvZ
    start_survey = 1;
    end_survey = 1;
    if Ctrl.P_SURVEY == 1
        n_survey = 1;
        lenSurvey = length(Survey);
        for i=1:1:lenSurvey
            n_survey = n_survey * Survey(i).steps;
        end
        end_survey = n_survey;
    end
end

function [ ParamB, ParamT ] = setSurveyValue( Ctrl, ParamB, ParamT, Survey, cnt )
%CADLIVE_SETSURVEYVALUE p[^T[xC̔ԍ(ڂ\lFcnt)ɉParamTɒlZbg
%   p[^T[xC̔ԍ(ڂ\lFcnt)ɉParamTɒlZbg

    nsame = 1;
    lenSurvey = length(Survey);
    last_cnt = zeros(1, lenSurvey);
    f_direction = false(1, lenSurvey);
    
    % 񐔂ɉp[^lvZ
    for i=1:1:lenSurvey
        index = Survey(i).index;
        steps = Survey(i).steps;
        my_cnt = mod( (cnt / nsame), steps);
        
        % \o[̏ꍇ͕ύXŏɂȂ悤ɐݒ肷
        if Ctrl.SOLVER > 10
            % \o[̏ꍇ
            if last_cnt(i) ~= my_cnt && my_cnt == 0
                if f_direction(i) == false 
                    f_direction(i) = true;
                else
                    f_direction(i) = false;
                end
            end
            
            if f_direction(i) == true
                step = (steps - 1) - my_cnt;
            else
                step = my_cnt;
            end
            last_cnt(i) = my_cnt;
        else
            % ԔW\o[̏ꍇ
            step = my_cnt;
        end
        
        % ݒľvZ
        if Survey(i).isArithmeticis 
            % 
            value = Survey(i).start_value + Survey(i).change_value * step;
        else
            value = Survey(i).start_value * (Survey(i).change_value ^ step);
        end
        
        % ParamTɒlZbg
        ParamB.(Survey(i).name)(index).value = value;
        ParamT = ParamB;
        
        nsame = nsame * steps;
    end

end
