function info = CADLIVE_writeTPSinfo( time, info, solution, searchParam, step)

if step == 0
	
	%œKꂽp^㏑Ȃ悤ɂ
	f=0;
	while 1
		if f==0
			tpsFile = 'TPSresult.mat';
			qmpsFile = 'TPStoQMPS.mat';
		else
			tpsFile = sprintf('TPSresult_%d.mat',f);
			qmpsFile = sprintf('TPStoQMPS_%d.mat',f);
		end
		if exist(tpsFile, 'file')
			f=f+1;
		else
			info.tpsFile=tpsFile;
			info.qmpsFile=qmpsFile;
			break;
		end
	end
	%fprintf(sprintf('Output %s.\n',info.tpsFile));
	
	fo = fopen('TPSResultInfo.dat','w');

	fprintf(fo,'$$Conditions\n');
	fprintf(fo,'Number of solutions setting: %d\n', info.term_n_solution);
	fprintf(fo,'AE: %e\n', info.AE);
	fprintf(fo,'AEC: %e\n', info.AEC);
	fprintf(fo,'RRIG: %f\n', info.RRIG);
	fprintf(fo,'Number of maximum generation: %d\n', info.n_generation);
	fprintf(fo,'Number of population: %d\n', info.n_population);
	fprintf(fo,'Number of children generated: %d\n', info.n_children);
	fprintf(fo,'Search type: %s\n', char(info.searchType));
	fprintf(fo,'Alpha: %f\n', info.alpha);
	fprintf(fo,'Beta: %f\n', info.beta);

	fclose(fo);
	%fprintf('Output TPSresultinfo.dat.\n');
	
elseif step == 1
	
	fo = fopen('TPSResultInfo.dat','a');
	%fprintf('******Results*********\n');
	fprintf(fo,'\n$$Perfomances\n');
	fprintf(fo,'Calculation time: %d hour %d min %d sec\n',floor(time/(60*60)),floor(mod(time/60,60)),floor(mod(time,60)));
	%fprintf('Performance: %d hour %d min %d sec\n',floor(time/(60*60)),floor(mod(time/60,60)),floor(mod(time,60)));
	fprintf(fo,'Number of trials for TPS: %d\n',info.n_trial);
	%fprintf('Number of searches: %d\n',info.n_rs);
	fprintf(fo,'EVA: %d\n',info.n_evaluation);
	%fprintf('EVA: %d\n',info.n_evaluation);
	fprintf(fo,'Number of solutions obtained: %d\n',info.n_solution);
	%fprintf(fo,'Number of coarse solutions: %d\n',info.n_coarse_solution);
	fprintf(fo,'Number of solutions obtained in RS: %d\n',info.n_rs);
	fprintf(fo,'Number of solutions obtained in GA: %d\n',info.n_solution_obtained_in_GA);
	fprintf(fo,'Number of solutions obtained in first generation of GA: %d\n',info.n_solution_obtained_in_first_generation);
	%fprintf('**********************\n');

	for i=1:length(searchParam)
		for j=1:length(solution)
			searchParam(i).value(j)=solution(j).paramValue(i);
		end
	end

	fprintf(fo,'\n$$search parameters\n');
	fprintf(fo,'parameter name\taverage\tstandard deviation\tmax\tmin\tmedian\tsetting upperbound\tsetting lowerbound\n');
	for i=1:length(searchParam)
		fprintf(fo,'%s(%d)\t',char(searchParam(i).paramName),searchParam(i).paramIndex);
		fprintf(fo,'%e\t', mean(searchParam(i).value));
		fprintf(fo,'%e\t', std(searchParam(i).value));
		fprintf(fo,'%e\t', max(searchParam(i).value));
		fprintf(fo,'%e\t', min(searchParam(i).value));
		fprintf(fo,'%e\t', median(searchParam(i).value));
		fprintf(fo,'%e\t', searchParam(i).upperBound);
		fprintf(fo,'%e\n', searchParam(i).lowerBound);
	end
	fclose(fo);
	
	fprintf(sprintf('Output %s.\n',info.tpsFile));
	fprintf('Output TPSresultinfo.dat.\n');
end


